package org.eclipse.lsat.setting.teditor.parser.antlr.internal;

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import org.eclipse.lsat.setting.teditor.services.SettingGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

/**
 * Copyright (c) 2021 Contributors to the Eclipse Foundation
 *
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Do not edit: This file is generated by Xtext
 */
@SuppressWarnings("all")
public class InternalSettingParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_STRING", "RULE_ID", "RULE_INT", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'import'", "'.'", "'{'", "'Timings'", "'}'", "'Axis'", "'Profiles'", "'Positions'", "'Distances'", "'='", "'('", "','", "')'", "'min'", "'max'", "'default'", "'Array'", "'Triangular'", "'mode'", "'Pert'", "'gamma'", "'Normal'", "'mean'", "'sd'", "'Enumerated'", "'val'", "'+'", "'-'", "'*'", "'/'", "'E'", "'e'"
    };
    public static final int RULE_STRING=4;
    public static final int RULE_SL_COMMENT=8;
    public static final int T__19=19;
    public static final int T__15=15;
    public static final int T__37=37;
    public static final int T__16=16;
    public static final int T__38=38;
    public static final int T__17=17;
    public static final int T__39=39;
    public static final int T__18=18;
    public static final int T__11=11;
    public static final int T__33=33;
    public static final int T__12=12;
    public static final int T__34=34;
    public static final int T__13=13;
    public static final int T__35=35;
    public static final int T__14=14;
    public static final int T__36=36;
    public static final int EOF=-1;
    public static final int T__30=30;
    public static final int T__31=31;
    public static final int T__32=32;
    public static final int RULE_ID=5;
    public static final int RULE_WS=9;
    public static final int RULE_ANY_OTHER=10;
    public static final int T__26=26;
    public static final int T__27=27;
    public static final int T__28=28;
    public static final int RULE_INT=6;
    public static final int T__29=29;
    public static final int T__22=22;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__23=23;
    public static final int T__24=24;
    public static final int T__25=25;
    public static final int T__40=40;
    public static final int T__41=41;
    public static final int T__20=20;
    public static final int T__42=42;
    public static final int T__21=21;

    // delegates
    // delegators


        public InternalSettingParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalSettingParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalSettingParser.tokenNames; }
    public String getGrammarFileName() { return "InternalSetting.g"; }



     	private SettingGrammarAccess grammarAccess;

        public InternalSettingParser(TokenStream input, SettingGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }

        @Override
        protected String getFirstRuleName() {
        	return "Settings";
       	}

       	@Override
       	protected SettingGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}




    // $ANTLR start "entryRuleSettings"
    // InternalSetting.g:72:1: entryRuleSettings returns [EObject current=null] : iv_ruleSettings= ruleSettings EOF ;
    public final EObject entryRuleSettings() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleSettings = null;


        try {
            // InternalSetting.g:72:49: (iv_ruleSettings= ruleSettings EOF )
            // InternalSetting.g:73:2: iv_ruleSettings= ruleSettings EOF
            {
             newCompositeNode(grammarAccess.getSettingsRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleSettings=ruleSettings();

            state._fsp--;

             current =iv_ruleSettings; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleSettings"


    // $ANTLR start "ruleSettings"
    // InternalSetting.g:79:1: ruleSettings returns [EObject current=null] : ( () ( (lv_imports_1_0= ruleImport ) )* ( (lv_declarations_2_0= ruleDeclaration ) )* ( (lv_physicalSettings_3_0= rulePhysicalSettings ) )* ) ;
    public final EObject ruleSettings() throws RecognitionException {
        EObject current = null;

        EObject lv_imports_1_0 = null;

        EObject lv_declarations_2_0 = null;

        EObject lv_physicalSettings_3_0 = null;



        	enterRule();

        try {
            // InternalSetting.g:85:2: ( ( () ( (lv_imports_1_0= ruleImport ) )* ( (lv_declarations_2_0= ruleDeclaration ) )* ( (lv_physicalSettings_3_0= rulePhysicalSettings ) )* ) )
            // InternalSetting.g:86:2: ( () ( (lv_imports_1_0= ruleImport ) )* ( (lv_declarations_2_0= ruleDeclaration ) )* ( (lv_physicalSettings_3_0= rulePhysicalSettings ) )* )
            {
            // InternalSetting.g:86:2: ( () ( (lv_imports_1_0= ruleImport ) )* ( (lv_declarations_2_0= ruleDeclaration ) )* ( (lv_physicalSettings_3_0= rulePhysicalSettings ) )* )
            // InternalSetting.g:87:3: () ( (lv_imports_1_0= ruleImport ) )* ( (lv_declarations_2_0= ruleDeclaration ) )* ( (lv_physicalSettings_3_0= rulePhysicalSettings ) )*
            {
            // InternalSetting.g:87:3: ()
            // InternalSetting.g:88:4: 
            {

            				current = forceCreateModelElement(
            					grammarAccess.getSettingsAccess().getSettingsAction_0(),
            					current);
            			

            }

            // InternalSetting.g:94:3: ( (lv_imports_1_0= ruleImport ) )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==11) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // InternalSetting.g:95:4: (lv_imports_1_0= ruleImport )
            	    {
            	    // InternalSetting.g:95:4: (lv_imports_1_0= ruleImport )
            	    // InternalSetting.g:96:5: lv_imports_1_0= ruleImport
            	    {

            	    					newCompositeNode(grammarAccess.getSettingsAccess().getImportsImportParserRuleCall_1_0());
            	    				
            	    pushFollow(FOLLOW_3);
            	    lv_imports_1_0=ruleImport();

            	    state._fsp--;


            	    					if (current==null) {
            	    						current = createModelElementForParent(grammarAccess.getSettingsRule());
            	    					}
            	    					add(
            	    						current,
            	    						"imports",
            	    						lv_imports_1_0,
            	    						"org.eclipse.lsat.setting.teditor.Setting.Import");
            	    					afterParserOrEnumRuleCall();
            	    				

            	    }


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

            // InternalSetting.g:113:3: ( (lv_declarations_2_0= ruleDeclaration ) )*
            loop2:
            do {
                int alt2=2;
                int LA2_0 = input.LA(1);

                if ( (LA2_0==36) ) {
                    alt2=1;
                }


                switch (alt2) {
            	case 1 :
            	    // InternalSetting.g:114:4: (lv_declarations_2_0= ruleDeclaration )
            	    {
            	    // InternalSetting.g:114:4: (lv_declarations_2_0= ruleDeclaration )
            	    // InternalSetting.g:115:5: lv_declarations_2_0= ruleDeclaration
            	    {

            	    					newCompositeNode(grammarAccess.getSettingsAccess().getDeclarationsDeclarationParserRuleCall_2_0());
            	    				
            	    pushFollow(FOLLOW_4);
            	    lv_declarations_2_0=ruleDeclaration();

            	    state._fsp--;


            	    					if (current==null) {
            	    						current = createModelElementForParent(grammarAccess.getSettingsRule());
            	    					}
            	    					add(
            	    						current,
            	    						"declarations",
            	    						lv_declarations_2_0,
            	    						"org.eclipse.lsat.setting.teditor.Setting.Declaration");
            	    					afterParserOrEnumRuleCall();
            	    				

            	    }


            	    }
            	    break;

            	default :
            	    break loop2;
                }
            } while (true);

            // InternalSetting.g:132:3: ( (lv_physicalSettings_3_0= rulePhysicalSettings ) )*
            loop3:
            do {
                int alt3=2;
                int LA3_0 = input.LA(1);

                if ( ((LA3_0>=RULE_ID && LA3_0<=RULE_INT)) ) {
                    alt3=1;
                }


                switch (alt3) {
            	case 1 :
            	    // InternalSetting.g:133:4: (lv_physicalSettings_3_0= rulePhysicalSettings )
            	    {
            	    // InternalSetting.g:133:4: (lv_physicalSettings_3_0= rulePhysicalSettings )
            	    // InternalSetting.g:134:5: lv_physicalSettings_3_0= rulePhysicalSettings
            	    {

            	    					newCompositeNode(grammarAccess.getSettingsAccess().getPhysicalSettingsPhysicalSettingsParserRuleCall_3_0());
            	    				
            	    pushFollow(FOLLOW_5);
            	    lv_physicalSettings_3_0=rulePhysicalSettings();

            	    state._fsp--;


            	    					if (current==null) {
            	    						current = createModelElementForParent(grammarAccess.getSettingsRule());
            	    					}
            	    					add(
            	    						current,
            	    						"physicalSettings",
            	    						lv_physicalSettings_3_0,
            	    						"org.eclipse.lsat.setting.teditor.Setting.PhysicalSettings");
            	    					afterParserOrEnumRuleCall();
            	    				

            	    }


            	    }
            	    break;

            	default :
            	    break loop3;
                }
            } while (true);


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleSettings"


    // $ANTLR start "entryRuleImport"
    // InternalSetting.g:155:1: entryRuleImport returns [EObject current=null] : iv_ruleImport= ruleImport EOF ;
    public final EObject entryRuleImport() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleImport = null;


        try {
            // InternalSetting.g:155:47: (iv_ruleImport= ruleImport EOF )
            // InternalSetting.g:156:2: iv_ruleImport= ruleImport EOF
            {
             newCompositeNode(grammarAccess.getImportRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleImport=ruleImport();

            state._fsp--;

             current =iv_ruleImport; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleImport"


    // $ANTLR start "ruleImport"
    // InternalSetting.g:162:1: ruleImport returns [EObject current=null] : (otherlv_0= 'import' ( (lv_importURI_1_0= RULE_STRING ) ) ) ;
    public final EObject ruleImport() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_importURI_1_0=null;


        	enterRule();

        try {
            // InternalSetting.g:168:2: ( (otherlv_0= 'import' ( (lv_importURI_1_0= RULE_STRING ) ) ) )
            // InternalSetting.g:169:2: (otherlv_0= 'import' ( (lv_importURI_1_0= RULE_STRING ) ) )
            {
            // InternalSetting.g:169:2: (otherlv_0= 'import' ( (lv_importURI_1_0= RULE_STRING ) ) )
            // InternalSetting.g:170:3: otherlv_0= 'import' ( (lv_importURI_1_0= RULE_STRING ) )
            {
            otherlv_0=(Token)match(input,11,FOLLOW_6); 

            			newLeafNode(otherlv_0, grammarAccess.getImportAccess().getImportKeyword_0());
            		
            // InternalSetting.g:174:3: ( (lv_importURI_1_0= RULE_STRING ) )
            // InternalSetting.g:175:4: (lv_importURI_1_0= RULE_STRING )
            {
            // InternalSetting.g:175:4: (lv_importURI_1_0= RULE_STRING )
            // InternalSetting.g:176:5: lv_importURI_1_0= RULE_STRING
            {
            lv_importURI_1_0=(Token)match(input,RULE_STRING,FOLLOW_2); 

            					newLeafNode(lv_importURI_1_0, grammarAccess.getImportAccess().getImportURISTRINGTerminalRuleCall_1_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getImportRule());
            					}
            					setWithLastConsumed(
            						current,
            						"importURI",
            						lv_importURI_1_0,
            						"org.eclipse.xtext.common.Terminals.STRING");
            				

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleImport"


    // $ANTLR start "entryRulePhysicalSettings"
    // InternalSetting.g:196:1: entryRulePhysicalSettings returns [EObject current=null] : iv_rulePhysicalSettings= rulePhysicalSettings EOF ;
    public final EObject entryRulePhysicalSettings() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePhysicalSettings = null;


        try {
            // InternalSetting.g:196:57: (iv_rulePhysicalSettings= rulePhysicalSettings EOF )
            // InternalSetting.g:197:2: iv_rulePhysicalSettings= rulePhysicalSettings EOF
            {
             newCompositeNode(grammarAccess.getPhysicalSettingsRule()); 
            pushFollow(FOLLOW_1);
            iv_rulePhysicalSettings=rulePhysicalSettings();

            state._fsp--;

             current =iv_rulePhysicalSettings; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulePhysicalSettings"


    // $ANTLR start "rulePhysicalSettings"
    // InternalSetting.g:203:1: rulePhysicalSettings returns [EObject current=null] : ( () ( ( ruleResourceQualifiedName ) ) otherlv_2= '.' ( ( ruleIID ) ) otherlv_4= '{' (otherlv_5= 'Timings' otherlv_6= '{' ( (lv_timingSettings_7_0= ruleTimingSettingsMapEntry ) )* otherlv_8= '}' )? ( (lv_motionSettings_9_0= ruleMotionSettingsMapEntry ) )* otherlv_10= '}' ) ;
    public final EObject rulePhysicalSettings() throws RecognitionException {
        EObject current = null;

        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        Token otherlv_6=null;
        Token otherlv_8=null;
        Token otherlv_10=null;
        EObject lv_timingSettings_7_0 = null;

        EObject lv_motionSettings_9_0 = null;



        	enterRule();

        try {
            // InternalSetting.g:209:2: ( ( () ( ( ruleResourceQualifiedName ) ) otherlv_2= '.' ( ( ruleIID ) ) otherlv_4= '{' (otherlv_5= 'Timings' otherlv_6= '{' ( (lv_timingSettings_7_0= ruleTimingSettingsMapEntry ) )* otherlv_8= '}' )? ( (lv_motionSettings_9_0= ruleMotionSettingsMapEntry ) )* otherlv_10= '}' ) )
            // InternalSetting.g:210:2: ( () ( ( ruleResourceQualifiedName ) ) otherlv_2= '.' ( ( ruleIID ) ) otherlv_4= '{' (otherlv_5= 'Timings' otherlv_6= '{' ( (lv_timingSettings_7_0= ruleTimingSettingsMapEntry ) )* otherlv_8= '}' )? ( (lv_motionSettings_9_0= ruleMotionSettingsMapEntry ) )* otherlv_10= '}' )
            {
            // InternalSetting.g:210:2: ( () ( ( ruleResourceQualifiedName ) ) otherlv_2= '.' ( ( ruleIID ) ) otherlv_4= '{' (otherlv_5= 'Timings' otherlv_6= '{' ( (lv_timingSettings_7_0= ruleTimingSettingsMapEntry ) )* otherlv_8= '}' )? ( (lv_motionSettings_9_0= ruleMotionSettingsMapEntry ) )* otherlv_10= '}' )
            // InternalSetting.g:211:3: () ( ( ruleResourceQualifiedName ) ) otherlv_2= '.' ( ( ruleIID ) ) otherlv_4= '{' (otherlv_5= 'Timings' otherlv_6= '{' ( (lv_timingSettings_7_0= ruleTimingSettingsMapEntry ) )* otherlv_8= '}' )? ( (lv_motionSettings_9_0= ruleMotionSettingsMapEntry ) )* otherlv_10= '}'
            {
            // InternalSetting.g:211:3: ()
            // InternalSetting.g:212:4: 
            {

            				current = forceCreateModelElement(
            					grammarAccess.getPhysicalSettingsAccess().getPhysicalSettingsAction_0(),
            					current);
            			

            }

            // InternalSetting.g:218:3: ( ( ruleResourceQualifiedName ) )
            // InternalSetting.g:219:4: ( ruleResourceQualifiedName )
            {
            // InternalSetting.g:219:4: ( ruleResourceQualifiedName )
            // InternalSetting.g:220:5: ruleResourceQualifiedName
            {

            					if (current==null) {
            						current = createModelElement(grammarAccess.getPhysicalSettingsRule());
            					}
            				

            					newCompositeNode(grammarAccess.getPhysicalSettingsAccess().getResourceIResourceCrossReference_1_0());
            				
            pushFollow(FOLLOW_7);
            ruleResourceQualifiedName();

            state._fsp--;


            					afterParserOrEnumRuleCall();
            				

            }


            }

            otherlv_2=(Token)match(input,12,FOLLOW_8); 

            			newLeafNode(otherlv_2, grammarAccess.getPhysicalSettingsAccess().getFullStopKeyword_2());
            		
            // InternalSetting.g:238:3: ( ( ruleIID ) )
            // InternalSetting.g:239:4: ( ruleIID )
            {
            // InternalSetting.g:239:4: ( ruleIID )
            // InternalSetting.g:240:5: ruleIID
            {

            					if (current==null) {
            						current = createModelElement(grammarAccess.getPhysicalSettingsRule());
            					}
            				

            					newCompositeNode(grammarAccess.getPhysicalSettingsAccess().getPeripheralPeripheralCrossReference_3_0());
            				
            pushFollow(FOLLOW_9);
            ruleIID();

            state._fsp--;


            					afterParserOrEnumRuleCall();
            				

            }


            }

            otherlv_4=(Token)match(input,13,FOLLOW_10); 

            			newLeafNode(otherlv_4, grammarAccess.getPhysicalSettingsAccess().getLeftCurlyBracketKeyword_4());
            		
            // InternalSetting.g:258:3: (otherlv_5= 'Timings' otherlv_6= '{' ( (lv_timingSettings_7_0= ruleTimingSettingsMapEntry ) )* otherlv_8= '}' )?
            int alt5=2;
            int LA5_0 = input.LA(1);

            if ( (LA5_0==14) ) {
                alt5=1;
            }
            switch (alt5) {
                case 1 :
                    // InternalSetting.g:259:4: otherlv_5= 'Timings' otherlv_6= '{' ( (lv_timingSettings_7_0= ruleTimingSettingsMapEntry ) )* otherlv_8= '}'
                    {
                    otherlv_5=(Token)match(input,14,FOLLOW_9); 

                    				newLeafNode(otherlv_5, grammarAccess.getPhysicalSettingsAccess().getTimingsKeyword_5_0());
                    			
                    otherlv_6=(Token)match(input,13,FOLLOW_11); 

                    				newLeafNode(otherlv_6, grammarAccess.getPhysicalSettingsAccess().getLeftCurlyBracketKeyword_5_1());
                    			
                    // InternalSetting.g:267:4: ( (lv_timingSettings_7_0= ruleTimingSettingsMapEntry ) )*
                    loop4:
                    do {
                        int alt4=2;
                        int LA4_0 = input.LA(1);

                        if ( (LA4_0==RULE_ID) ) {
                            alt4=1;
                        }


                        switch (alt4) {
                    	case 1 :
                    	    // InternalSetting.g:268:5: (lv_timingSettings_7_0= ruleTimingSettingsMapEntry )
                    	    {
                    	    // InternalSetting.g:268:5: (lv_timingSettings_7_0= ruleTimingSettingsMapEntry )
                    	    // InternalSetting.g:269:6: lv_timingSettings_7_0= ruleTimingSettingsMapEntry
                    	    {

                    	    						newCompositeNode(grammarAccess.getPhysicalSettingsAccess().getTimingSettingsTimingSettingsMapEntryParserRuleCall_5_2_0());
                    	    					
                    	    pushFollow(FOLLOW_11);
                    	    lv_timingSettings_7_0=ruleTimingSettingsMapEntry();

                    	    state._fsp--;


                    	    						if (current==null) {
                    	    							current = createModelElementForParent(grammarAccess.getPhysicalSettingsRule());
                    	    						}
                    	    						add(
                    	    							current,
                    	    							"timingSettings",
                    	    							lv_timingSettings_7_0,
                    	    							"org.eclipse.lsat.setting.teditor.Setting.TimingSettingsMapEntry");
                    	    						afterParserOrEnumRuleCall();
                    	    					

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop4;
                        }
                    } while (true);

                    otherlv_8=(Token)match(input,15,FOLLOW_12); 

                    				newLeafNode(otherlv_8, grammarAccess.getPhysicalSettingsAccess().getRightCurlyBracketKeyword_5_3());
                    			

                    }
                    break;

            }

            // InternalSetting.g:291:3: ( (lv_motionSettings_9_0= ruleMotionSettingsMapEntry ) )*
            loop6:
            do {
                int alt6=2;
                int LA6_0 = input.LA(1);

                if ( (LA6_0==16) ) {
                    alt6=1;
                }


                switch (alt6) {
            	case 1 :
            	    // InternalSetting.g:292:4: (lv_motionSettings_9_0= ruleMotionSettingsMapEntry )
            	    {
            	    // InternalSetting.g:292:4: (lv_motionSettings_9_0= ruleMotionSettingsMapEntry )
            	    // InternalSetting.g:293:5: lv_motionSettings_9_0= ruleMotionSettingsMapEntry
            	    {

            	    					newCompositeNode(grammarAccess.getPhysicalSettingsAccess().getMotionSettingsMotionSettingsMapEntryParserRuleCall_6_0());
            	    				
            	    pushFollow(FOLLOW_12);
            	    lv_motionSettings_9_0=ruleMotionSettingsMapEntry();

            	    state._fsp--;


            	    					if (current==null) {
            	    						current = createModelElementForParent(grammarAccess.getPhysicalSettingsRule());
            	    					}
            	    					add(
            	    						current,
            	    						"motionSettings",
            	    						lv_motionSettings_9_0,
            	    						"org.eclipse.lsat.setting.teditor.Setting.MotionSettingsMapEntry");
            	    					afterParserOrEnumRuleCall();
            	    				

            	    }


            	    }
            	    break;

            	default :
            	    break loop6;
                }
            } while (true);

            otherlv_10=(Token)match(input,15,FOLLOW_2); 

            			newLeafNode(otherlv_10, grammarAccess.getPhysicalSettingsAccess().getRightCurlyBracketKeyword_7());
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "rulePhysicalSettings"


    // $ANTLR start "entryRuleMotionSettingsMapEntry"
    // InternalSetting.g:318:1: entryRuleMotionSettingsMapEntry returns [EObject current=null] : iv_ruleMotionSettingsMapEntry= ruleMotionSettingsMapEntry EOF ;
    public final EObject entryRuleMotionSettingsMapEntry() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleMotionSettingsMapEntry = null;


        try {
            // InternalSetting.g:318:63: (iv_ruleMotionSettingsMapEntry= ruleMotionSettingsMapEntry EOF )
            // InternalSetting.g:319:2: iv_ruleMotionSettingsMapEntry= ruleMotionSettingsMapEntry EOF
            {
             newCompositeNode(grammarAccess.getMotionSettingsMapEntryRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleMotionSettingsMapEntry=ruleMotionSettingsMapEntry();

            state._fsp--;

             current =iv_ruleMotionSettingsMapEntry; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleMotionSettingsMapEntry"


    // $ANTLR start "ruleMotionSettingsMapEntry"
    // InternalSetting.g:325:1: ruleMotionSettingsMapEntry returns [EObject current=null] : ( () otherlv_1= 'Axis' ( (otherlv_2= RULE_ID ) ) otherlv_3= '{' ( (lv_value_4_0= ruleMotionSettings ) ) otherlv_5= '}' ) ;
    public final EObject ruleMotionSettingsMapEntry() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_2=null;
        Token otherlv_3=null;
        Token otherlv_5=null;
        EObject lv_value_4_0 = null;



        	enterRule();

        try {
            // InternalSetting.g:331:2: ( ( () otherlv_1= 'Axis' ( (otherlv_2= RULE_ID ) ) otherlv_3= '{' ( (lv_value_4_0= ruleMotionSettings ) ) otherlv_5= '}' ) )
            // InternalSetting.g:332:2: ( () otherlv_1= 'Axis' ( (otherlv_2= RULE_ID ) ) otherlv_3= '{' ( (lv_value_4_0= ruleMotionSettings ) ) otherlv_5= '}' )
            {
            // InternalSetting.g:332:2: ( () otherlv_1= 'Axis' ( (otherlv_2= RULE_ID ) ) otherlv_3= '{' ( (lv_value_4_0= ruleMotionSettings ) ) otherlv_5= '}' )
            // InternalSetting.g:333:3: () otherlv_1= 'Axis' ( (otherlv_2= RULE_ID ) ) otherlv_3= '{' ( (lv_value_4_0= ruleMotionSettings ) ) otherlv_5= '}'
            {
            // InternalSetting.g:333:3: ()
            // InternalSetting.g:334:4: 
            {

            				current = forceCreateModelElement(
            					grammarAccess.getMotionSettingsMapEntryAccess().getMotionSettingsMapEntryAction_0(),
            					current);
            			

            }

            otherlv_1=(Token)match(input,16,FOLLOW_13); 

            			newLeafNode(otherlv_1, grammarAccess.getMotionSettingsMapEntryAccess().getAxisKeyword_1());
            		
            // InternalSetting.g:344:3: ( (otherlv_2= RULE_ID ) )
            // InternalSetting.g:345:4: (otherlv_2= RULE_ID )
            {
            // InternalSetting.g:345:4: (otherlv_2= RULE_ID )
            // InternalSetting.g:346:5: otherlv_2= RULE_ID
            {

            					if (current==null) {
            						current = createModelElement(grammarAccess.getMotionSettingsMapEntryRule());
            					}
            				
            otherlv_2=(Token)match(input,RULE_ID,FOLLOW_9); 

            					newLeafNode(otherlv_2, grammarAccess.getMotionSettingsMapEntryAccess().getKeyAxisCrossReference_2_0());
            				

            }


            }

            otherlv_3=(Token)match(input,13,FOLLOW_14); 

            			newLeafNode(otherlv_3, grammarAccess.getMotionSettingsMapEntryAccess().getLeftCurlyBracketKeyword_3());
            		
            // InternalSetting.g:361:3: ( (lv_value_4_0= ruleMotionSettings ) )
            // InternalSetting.g:362:4: (lv_value_4_0= ruleMotionSettings )
            {
            // InternalSetting.g:362:4: (lv_value_4_0= ruleMotionSettings )
            // InternalSetting.g:363:5: lv_value_4_0= ruleMotionSettings
            {

            					newCompositeNode(grammarAccess.getMotionSettingsMapEntryAccess().getValueMotionSettingsParserRuleCall_4_0());
            				
            pushFollow(FOLLOW_15);
            lv_value_4_0=ruleMotionSettings();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getMotionSettingsMapEntryRule());
            					}
            					set(
            						current,
            						"value",
            						lv_value_4_0,
            						"org.eclipse.lsat.setting.teditor.Setting.MotionSettings");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            otherlv_5=(Token)match(input,15,FOLLOW_2); 

            			newLeafNode(otherlv_5, grammarAccess.getMotionSettingsMapEntryAccess().getRightCurlyBracketKeyword_5());
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleMotionSettingsMapEntry"


    // $ANTLR start "entryRuleMotionSettings"
    // InternalSetting.g:388:1: entryRuleMotionSettings returns [EObject current=null] : iv_ruleMotionSettings= ruleMotionSettings EOF ;
    public final EObject entryRuleMotionSettings() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleMotionSettings = null;


        try {
            // InternalSetting.g:388:55: (iv_ruleMotionSettings= ruleMotionSettings EOF )
            // InternalSetting.g:389:2: iv_ruleMotionSettings= ruleMotionSettings EOF
            {
             newCompositeNode(grammarAccess.getMotionSettingsRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleMotionSettings=ruleMotionSettings();

            state._fsp--;

             current =iv_ruleMotionSettings; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleMotionSettings"


    // $ANTLR start "ruleMotionSettings"
    // InternalSetting.g:395:1: ruleMotionSettings returns [EObject current=null] : ( () otherlv_1= 'Profiles' otherlv_2= '{' ( (lv_profileSettings_3_0= ruleProfileSettingsMapEntry ) )* otherlv_4= '}' (otherlv_5= 'Positions' otherlv_6= '{' ( (lv_locationSettings_7_0= ruleLocationSettingsMapEntry ) )* otherlv_8= '}' )? (otherlv_9= 'Distances' otherlv_10= '{' ( (lv_distanceSettings_11_0= ruleDistanceSettingsMapEntry ) )* otherlv_12= '}' )? ) ;
    public final EObject ruleMotionSettings() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        Token otherlv_6=null;
        Token otherlv_8=null;
        Token otherlv_9=null;
        Token otherlv_10=null;
        Token otherlv_12=null;
        EObject lv_profileSettings_3_0 = null;

        EObject lv_locationSettings_7_0 = null;

        EObject lv_distanceSettings_11_0 = null;



        	enterRule();

        try {
            // InternalSetting.g:401:2: ( ( () otherlv_1= 'Profiles' otherlv_2= '{' ( (lv_profileSettings_3_0= ruleProfileSettingsMapEntry ) )* otherlv_4= '}' (otherlv_5= 'Positions' otherlv_6= '{' ( (lv_locationSettings_7_0= ruleLocationSettingsMapEntry ) )* otherlv_8= '}' )? (otherlv_9= 'Distances' otherlv_10= '{' ( (lv_distanceSettings_11_0= ruleDistanceSettingsMapEntry ) )* otherlv_12= '}' )? ) )
            // InternalSetting.g:402:2: ( () otherlv_1= 'Profiles' otherlv_2= '{' ( (lv_profileSettings_3_0= ruleProfileSettingsMapEntry ) )* otherlv_4= '}' (otherlv_5= 'Positions' otherlv_6= '{' ( (lv_locationSettings_7_0= ruleLocationSettingsMapEntry ) )* otherlv_8= '}' )? (otherlv_9= 'Distances' otherlv_10= '{' ( (lv_distanceSettings_11_0= ruleDistanceSettingsMapEntry ) )* otherlv_12= '}' )? )
            {
            // InternalSetting.g:402:2: ( () otherlv_1= 'Profiles' otherlv_2= '{' ( (lv_profileSettings_3_0= ruleProfileSettingsMapEntry ) )* otherlv_4= '}' (otherlv_5= 'Positions' otherlv_6= '{' ( (lv_locationSettings_7_0= ruleLocationSettingsMapEntry ) )* otherlv_8= '}' )? (otherlv_9= 'Distances' otherlv_10= '{' ( (lv_distanceSettings_11_0= ruleDistanceSettingsMapEntry ) )* otherlv_12= '}' )? )
            // InternalSetting.g:403:3: () otherlv_1= 'Profiles' otherlv_2= '{' ( (lv_profileSettings_3_0= ruleProfileSettingsMapEntry ) )* otherlv_4= '}' (otherlv_5= 'Positions' otherlv_6= '{' ( (lv_locationSettings_7_0= ruleLocationSettingsMapEntry ) )* otherlv_8= '}' )? (otherlv_9= 'Distances' otherlv_10= '{' ( (lv_distanceSettings_11_0= ruleDistanceSettingsMapEntry ) )* otherlv_12= '}' )?
            {
            // InternalSetting.g:403:3: ()
            // InternalSetting.g:404:4: 
            {

            				current = forceCreateModelElement(
            					grammarAccess.getMotionSettingsAccess().getMotionSettingsAction_0(),
            					current);
            			

            }

            otherlv_1=(Token)match(input,17,FOLLOW_9); 

            			newLeafNode(otherlv_1, grammarAccess.getMotionSettingsAccess().getProfilesKeyword_1());
            		
            otherlv_2=(Token)match(input,13,FOLLOW_11); 

            			newLeafNode(otherlv_2, grammarAccess.getMotionSettingsAccess().getLeftCurlyBracketKeyword_2());
            		
            // InternalSetting.g:418:3: ( (lv_profileSettings_3_0= ruleProfileSettingsMapEntry ) )*
            loop7:
            do {
                int alt7=2;
                int LA7_0 = input.LA(1);

                if ( (LA7_0==RULE_ID) ) {
                    alt7=1;
                }


                switch (alt7) {
            	case 1 :
            	    // InternalSetting.g:419:4: (lv_profileSettings_3_0= ruleProfileSettingsMapEntry )
            	    {
            	    // InternalSetting.g:419:4: (lv_profileSettings_3_0= ruleProfileSettingsMapEntry )
            	    // InternalSetting.g:420:5: lv_profileSettings_3_0= ruleProfileSettingsMapEntry
            	    {

            	    					newCompositeNode(grammarAccess.getMotionSettingsAccess().getProfileSettingsProfileSettingsMapEntryParserRuleCall_3_0());
            	    				
            	    pushFollow(FOLLOW_11);
            	    lv_profileSettings_3_0=ruleProfileSettingsMapEntry();

            	    state._fsp--;


            	    					if (current==null) {
            	    						current = createModelElementForParent(grammarAccess.getMotionSettingsRule());
            	    					}
            	    					add(
            	    						current,
            	    						"profileSettings",
            	    						lv_profileSettings_3_0,
            	    						"org.eclipse.lsat.setting.teditor.Setting.ProfileSettingsMapEntry");
            	    					afterParserOrEnumRuleCall();
            	    				

            	    }


            	    }
            	    break;

            	default :
            	    break loop7;
                }
            } while (true);

            otherlv_4=(Token)match(input,15,FOLLOW_16); 

            			newLeafNode(otherlv_4, grammarAccess.getMotionSettingsAccess().getRightCurlyBracketKeyword_4());
            		
            // InternalSetting.g:441:3: (otherlv_5= 'Positions' otherlv_6= '{' ( (lv_locationSettings_7_0= ruleLocationSettingsMapEntry ) )* otherlv_8= '}' )?
            int alt9=2;
            int LA9_0 = input.LA(1);

            if ( (LA9_0==18) ) {
                alt9=1;
            }
            switch (alt9) {
                case 1 :
                    // InternalSetting.g:442:4: otherlv_5= 'Positions' otherlv_6= '{' ( (lv_locationSettings_7_0= ruleLocationSettingsMapEntry ) )* otherlv_8= '}'
                    {
                    otherlv_5=(Token)match(input,18,FOLLOW_9); 

                    				newLeafNode(otherlv_5, grammarAccess.getMotionSettingsAccess().getPositionsKeyword_5_0());
                    			
                    otherlv_6=(Token)match(input,13,FOLLOW_11); 

                    				newLeafNode(otherlv_6, grammarAccess.getMotionSettingsAccess().getLeftCurlyBracketKeyword_5_1());
                    			
                    // InternalSetting.g:450:4: ( (lv_locationSettings_7_0= ruleLocationSettingsMapEntry ) )*
                    loop8:
                    do {
                        int alt8=2;
                        int LA8_0 = input.LA(1);

                        if ( (LA8_0==RULE_ID) ) {
                            alt8=1;
                        }


                        switch (alt8) {
                    	case 1 :
                    	    // InternalSetting.g:451:5: (lv_locationSettings_7_0= ruleLocationSettingsMapEntry )
                    	    {
                    	    // InternalSetting.g:451:5: (lv_locationSettings_7_0= ruleLocationSettingsMapEntry )
                    	    // InternalSetting.g:452:6: lv_locationSettings_7_0= ruleLocationSettingsMapEntry
                    	    {

                    	    						newCompositeNode(grammarAccess.getMotionSettingsAccess().getLocationSettingsLocationSettingsMapEntryParserRuleCall_5_2_0());
                    	    					
                    	    pushFollow(FOLLOW_11);
                    	    lv_locationSettings_7_0=ruleLocationSettingsMapEntry();

                    	    state._fsp--;


                    	    						if (current==null) {
                    	    							current = createModelElementForParent(grammarAccess.getMotionSettingsRule());
                    	    						}
                    	    						add(
                    	    							current,
                    	    							"locationSettings",
                    	    							lv_locationSettings_7_0,
                    	    							"org.eclipse.lsat.setting.teditor.Setting.LocationSettingsMapEntry");
                    	    						afterParserOrEnumRuleCall();
                    	    					

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop8;
                        }
                    } while (true);

                    otherlv_8=(Token)match(input,15,FOLLOW_17); 

                    				newLeafNode(otherlv_8, grammarAccess.getMotionSettingsAccess().getRightCurlyBracketKeyword_5_3());
                    			

                    }
                    break;

            }

            // InternalSetting.g:474:3: (otherlv_9= 'Distances' otherlv_10= '{' ( (lv_distanceSettings_11_0= ruleDistanceSettingsMapEntry ) )* otherlv_12= '}' )?
            int alt11=2;
            int LA11_0 = input.LA(1);

            if ( (LA11_0==19) ) {
                alt11=1;
            }
            switch (alt11) {
                case 1 :
                    // InternalSetting.g:475:4: otherlv_9= 'Distances' otherlv_10= '{' ( (lv_distanceSettings_11_0= ruleDistanceSettingsMapEntry ) )* otherlv_12= '}'
                    {
                    otherlv_9=(Token)match(input,19,FOLLOW_9); 

                    				newLeafNode(otherlv_9, grammarAccess.getMotionSettingsAccess().getDistancesKeyword_6_0());
                    			
                    otherlv_10=(Token)match(input,13,FOLLOW_11); 

                    				newLeafNode(otherlv_10, grammarAccess.getMotionSettingsAccess().getLeftCurlyBracketKeyword_6_1());
                    			
                    // InternalSetting.g:483:4: ( (lv_distanceSettings_11_0= ruleDistanceSettingsMapEntry ) )*
                    loop10:
                    do {
                        int alt10=2;
                        int LA10_0 = input.LA(1);

                        if ( (LA10_0==RULE_ID) ) {
                            alt10=1;
                        }


                        switch (alt10) {
                    	case 1 :
                    	    // InternalSetting.g:484:5: (lv_distanceSettings_11_0= ruleDistanceSettingsMapEntry )
                    	    {
                    	    // InternalSetting.g:484:5: (lv_distanceSettings_11_0= ruleDistanceSettingsMapEntry )
                    	    // InternalSetting.g:485:6: lv_distanceSettings_11_0= ruleDistanceSettingsMapEntry
                    	    {

                    	    						newCompositeNode(grammarAccess.getMotionSettingsAccess().getDistanceSettingsDistanceSettingsMapEntryParserRuleCall_6_2_0());
                    	    					
                    	    pushFollow(FOLLOW_11);
                    	    lv_distanceSettings_11_0=ruleDistanceSettingsMapEntry();

                    	    state._fsp--;


                    	    						if (current==null) {
                    	    							current = createModelElementForParent(grammarAccess.getMotionSettingsRule());
                    	    						}
                    	    						add(
                    	    							current,
                    	    							"distanceSettings",
                    	    							lv_distanceSettings_11_0,
                    	    							"org.eclipse.lsat.setting.teditor.Setting.DistanceSettingsMapEntry");
                    	    						afterParserOrEnumRuleCall();
                    	    					

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop10;
                        }
                    } while (true);

                    otherlv_12=(Token)match(input,15,FOLLOW_2); 

                    				newLeafNode(otherlv_12, grammarAccess.getMotionSettingsAccess().getRightCurlyBracketKeyword_6_3());
                    			

                    }
                    break;

            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleMotionSettings"


    // $ANTLR start "entryRuleProfileSettingsMapEntry"
    // InternalSetting.g:511:1: entryRuleProfileSettingsMapEntry returns [EObject current=null] : iv_ruleProfileSettingsMapEntry= ruleProfileSettingsMapEntry EOF ;
    public final EObject entryRuleProfileSettingsMapEntry() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleProfileSettingsMapEntry = null;


        try {
            // InternalSetting.g:511:64: (iv_ruleProfileSettingsMapEntry= ruleProfileSettingsMapEntry EOF )
            // InternalSetting.g:512:2: iv_ruleProfileSettingsMapEntry= ruleProfileSettingsMapEntry EOF
            {
             newCompositeNode(grammarAccess.getProfileSettingsMapEntryRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleProfileSettingsMapEntry=ruleProfileSettingsMapEntry();

            state._fsp--;

             current =iv_ruleProfileSettingsMapEntry; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleProfileSettingsMapEntry"


    // $ANTLR start "ruleProfileSettingsMapEntry"
    // InternalSetting.g:518:1: ruleProfileSettingsMapEntry returns [EObject current=null] : ( ( (otherlv_0= RULE_ID ) ) ( (lv_value_1_0= ruleMotionProfileSettings ) ) ) ;
    public final EObject ruleProfileSettingsMapEntry() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        EObject lv_value_1_0 = null;



        	enterRule();

        try {
            // InternalSetting.g:524:2: ( ( ( (otherlv_0= RULE_ID ) ) ( (lv_value_1_0= ruleMotionProfileSettings ) ) ) )
            // InternalSetting.g:525:2: ( ( (otherlv_0= RULE_ID ) ) ( (lv_value_1_0= ruleMotionProfileSettings ) ) )
            {
            // InternalSetting.g:525:2: ( ( (otherlv_0= RULE_ID ) ) ( (lv_value_1_0= ruleMotionProfileSettings ) ) )
            // InternalSetting.g:526:3: ( (otherlv_0= RULE_ID ) ) ( (lv_value_1_0= ruleMotionProfileSettings ) )
            {
            // InternalSetting.g:526:3: ( (otherlv_0= RULE_ID ) )
            // InternalSetting.g:527:4: (otherlv_0= RULE_ID )
            {
            // InternalSetting.g:527:4: (otherlv_0= RULE_ID )
            // InternalSetting.g:528:5: otherlv_0= RULE_ID
            {

            					if (current==null) {
            						current = createModelElement(grammarAccess.getProfileSettingsMapEntryRule());
            					}
            				
            otherlv_0=(Token)match(input,RULE_ID,FOLLOW_18); 

            					newLeafNode(otherlv_0, grammarAccess.getProfileSettingsMapEntryAccess().getKeyProfileCrossReference_0_0());
            				

            }


            }

            // InternalSetting.g:539:3: ( (lv_value_1_0= ruleMotionProfileSettings ) )
            // InternalSetting.g:540:4: (lv_value_1_0= ruleMotionProfileSettings )
            {
            // InternalSetting.g:540:4: (lv_value_1_0= ruleMotionProfileSettings )
            // InternalSetting.g:541:5: lv_value_1_0= ruleMotionProfileSettings
            {

            					newCompositeNode(grammarAccess.getProfileSettingsMapEntryAccess().getValueMotionProfileSettingsParserRuleCall_1_0());
            				
            pushFollow(FOLLOW_2);
            lv_value_1_0=ruleMotionProfileSettings();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getProfileSettingsMapEntryRule());
            					}
            					set(
            						current,
            						"value",
            						lv_value_1_0,
            						"org.eclipse.lsat.setting.teditor.Setting.MotionProfileSettings");
            					afterParserOrEnumRuleCall();
            				

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleProfileSettingsMapEntry"


    // $ANTLR start "entryRuleLocationSettingsMapEntry"
    // InternalSetting.g:562:1: entryRuleLocationSettingsMapEntry returns [EObject current=null] : iv_ruleLocationSettingsMapEntry= ruleLocationSettingsMapEntry EOF ;
    public final EObject entryRuleLocationSettingsMapEntry() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleLocationSettingsMapEntry = null;


        try {
            // InternalSetting.g:562:65: (iv_ruleLocationSettingsMapEntry= ruleLocationSettingsMapEntry EOF )
            // InternalSetting.g:563:2: iv_ruleLocationSettingsMapEntry= ruleLocationSettingsMapEntry EOF
            {
             newCompositeNode(grammarAccess.getLocationSettingsMapEntryRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleLocationSettingsMapEntry=ruleLocationSettingsMapEntry();

            state._fsp--;

             current =iv_ruleLocationSettingsMapEntry; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleLocationSettingsMapEntry"


    // $ANTLR start "ruleLocationSettingsMapEntry"
    // InternalSetting.g:569:1: ruleLocationSettingsMapEntry returns [EObject current=null] : ( ( (otherlv_0= RULE_ID ) ) ( (lv_value_1_0= rulePhysicalLocation ) ) ) ;
    public final EObject ruleLocationSettingsMapEntry() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        EObject lv_value_1_0 = null;



        	enterRule();

        try {
            // InternalSetting.g:575:2: ( ( ( (otherlv_0= RULE_ID ) ) ( (lv_value_1_0= rulePhysicalLocation ) ) ) )
            // InternalSetting.g:576:2: ( ( (otherlv_0= RULE_ID ) ) ( (lv_value_1_0= rulePhysicalLocation ) ) )
            {
            // InternalSetting.g:576:2: ( ( (otherlv_0= RULE_ID ) ) ( (lv_value_1_0= rulePhysicalLocation ) ) )
            // InternalSetting.g:577:3: ( (otherlv_0= RULE_ID ) ) ( (lv_value_1_0= rulePhysicalLocation ) )
            {
            // InternalSetting.g:577:3: ( (otherlv_0= RULE_ID ) )
            // InternalSetting.g:578:4: (otherlv_0= RULE_ID )
            {
            // InternalSetting.g:578:4: (otherlv_0= RULE_ID )
            // InternalSetting.g:579:5: otherlv_0= RULE_ID
            {

            					if (current==null) {
            						current = createModelElement(grammarAccess.getLocationSettingsMapEntryRule());
            					}
            				
            otherlv_0=(Token)match(input,RULE_ID,FOLLOW_19); 

            					newLeafNode(otherlv_0, grammarAccess.getLocationSettingsMapEntryAccess().getKeyPositionCrossReference_0_0());
            				

            }


            }

            // InternalSetting.g:590:3: ( (lv_value_1_0= rulePhysicalLocation ) )
            // InternalSetting.g:591:4: (lv_value_1_0= rulePhysicalLocation )
            {
            // InternalSetting.g:591:4: (lv_value_1_0= rulePhysicalLocation )
            // InternalSetting.g:592:5: lv_value_1_0= rulePhysicalLocation
            {

            					newCompositeNode(grammarAccess.getLocationSettingsMapEntryAccess().getValuePhysicalLocationParserRuleCall_1_0());
            				
            pushFollow(FOLLOW_2);
            lv_value_1_0=rulePhysicalLocation();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getLocationSettingsMapEntryRule());
            					}
            					set(
            						current,
            						"value",
            						lv_value_1_0,
            						"org.eclipse.lsat.setting.teditor.Setting.PhysicalLocation");
            					afterParserOrEnumRuleCall();
            				

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleLocationSettingsMapEntry"


    // $ANTLR start "entryRuleDistanceSettingsMapEntry"
    // InternalSetting.g:613:1: entryRuleDistanceSettingsMapEntry returns [EObject current=null] : iv_ruleDistanceSettingsMapEntry= ruleDistanceSettingsMapEntry EOF ;
    public final EObject entryRuleDistanceSettingsMapEntry() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleDistanceSettingsMapEntry = null;


        try {
            // InternalSetting.g:613:65: (iv_ruleDistanceSettingsMapEntry= ruleDistanceSettingsMapEntry EOF )
            // InternalSetting.g:614:2: iv_ruleDistanceSettingsMapEntry= ruleDistanceSettingsMapEntry EOF
            {
             newCompositeNode(grammarAccess.getDistanceSettingsMapEntryRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleDistanceSettingsMapEntry=ruleDistanceSettingsMapEntry();

            state._fsp--;

             current =iv_ruleDistanceSettingsMapEntry; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleDistanceSettingsMapEntry"


    // $ANTLR start "ruleDistanceSettingsMapEntry"
    // InternalSetting.g:620:1: ruleDistanceSettingsMapEntry returns [EObject current=null] : ( ( (otherlv_0= RULE_ID ) ) otherlv_1= '=' ( (lv_value_2_0= ruleExpression ) ) ) ;
    public final EObject ruleDistanceSettingsMapEntry() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_1=null;
        EObject lv_value_2_0 = null;



        	enterRule();

        try {
            // InternalSetting.g:626:2: ( ( ( (otherlv_0= RULE_ID ) ) otherlv_1= '=' ( (lv_value_2_0= ruleExpression ) ) ) )
            // InternalSetting.g:627:2: ( ( (otherlv_0= RULE_ID ) ) otherlv_1= '=' ( (lv_value_2_0= ruleExpression ) ) )
            {
            // InternalSetting.g:627:2: ( ( (otherlv_0= RULE_ID ) ) otherlv_1= '=' ( (lv_value_2_0= ruleExpression ) ) )
            // InternalSetting.g:628:3: ( (otherlv_0= RULE_ID ) ) otherlv_1= '=' ( (lv_value_2_0= ruleExpression ) )
            {
            // InternalSetting.g:628:3: ( (otherlv_0= RULE_ID ) )
            // InternalSetting.g:629:4: (otherlv_0= RULE_ID )
            {
            // InternalSetting.g:629:4: (otherlv_0= RULE_ID )
            // InternalSetting.g:630:5: otherlv_0= RULE_ID
            {

            					if (current==null) {
            						current = createModelElement(grammarAccess.getDistanceSettingsMapEntryRule());
            					}
            				
            otherlv_0=(Token)match(input,RULE_ID,FOLLOW_20); 

            					newLeafNode(otherlv_0, grammarAccess.getDistanceSettingsMapEntryAccess().getKeyDistanceCrossReference_0_0());
            				

            }


            }

            otherlv_1=(Token)match(input,20,FOLLOW_21); 

            			newLeafNode(otherlv_1, grammarAccess.getDistanceSettingsMapEntryAccess().getEqualsSignKeyword_1());
            		
            // InternalSetting.g:645:3: ( (lv_value_2_0= ruleExpression ) )
            // InternalSetting.g:646:4: (lv_value_2_0= ruleExpression )
            {
            // InternalSetting.g:646:4: (lv_value_2_0= ruleExpression )
            // InternalSetting.g:647:5: lv_value_2_0= ruleExpression
            {

            					newCompositeNode(grammarAccess.getDistanceSettingsMapEntryAccess().getValueExpressionParserRuleCall_2_0());
            				
            pushFollow(FOLLOW_2);
            lv_value_2_0=ruleExpression();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getDistanceSettingsMapEntryRule());
            					}
            					set(
            						current,
            						"value",
            						lv_value_2_0,
            						"org.eclipse.lsat.setting.teditor.Setting.Expression");
            					afterParserOrEnumRuleCall();
            				

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleDistanceSettingsMapEntry"


    // $ANTLR start "entryRuleTimingSettingsMapEntry"
    // InternalSetting.g:668:1: entryRuleTimingSettingsMapEntry returns [EObject current=null] : iv_ruleTimingSettingsMapEntry= ruleTimingSettingsMapEntry EOF ;
    public final EObject entryRuleTimingSettingsMapEntry() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleTimingSettingsMapEntry = null;


        try {
            // InternalSetting.g:668:63: (iv_ruleTimingSettingsMapEntry= ruleTimingSettingsMapEntry EOF )
            // InternalSetting.g:669:2: iv_ruleTimingSettingsMapEntry= ruleTimingSettingsMapEntry EOF
            {
             newCompositeNode(grammarAccess.getTimingSettingsMapEntryRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleTimingSettingsMapEntry=ruleTimingSettingsMapEntry();

            state._fsp--;

             current =iv_ruleTimingSettingsMapEntry; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleTimingSettingsMapEntry"


    // $ANTLR start "ruleTimingSettingsMapEntry"
    // InternalSetting.g:675:1: ruleTimingSettingsMapEntry returns [EObject current=null] : ( ( (otherlv_0= RULE_ID ) ) otherlv_1= '=' ( (lv_value_2_0= ruleTiming ) ) ) ;
    public final EObject ruleTimingSettingsMapEntry() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_1=null;
        EObject lv_value_2_0 = null;



        	enterRule();

        try {
            // InternalSetting.g:681:2: ( ( ( (otherlv_0= RULE_ID ) ) otherlv_1= '=' ( (lv_value_2_0= ruleTiming ) ) ) )
            // InternalSetting.g:682:2: ( ( (otherlv_0= RULE_ID ) ) otherlv_1= '=' ( (lv_value_2_0= ruleTiming ) ) )
            {
            // InternalSetting.g:682:2: ( ( (otherlv_0= RULE_ID ) ) otherlv_1= '=' ( (lv_value_2_0= ruleTiming ) ) )
            // InternalSetting.g:683:3: ( (otherlv_0= RULE_ID ) ) otherlv_1= '=' ( (lv_value_2_0= ruleTiming ) )
            {
            // InternalSetting.g:683:3: ( (otherlv_0= RULE_ID ) )
            // InternalSetting.g:684:4: (otherlv_0= RULE_ID )
            {
            // InternalSetting.g:684:4: (otherlv_0= RULE_ID )
            // InternalSetting.g:685:5: otherlv_0= RULE_ID
            {

            					if (current==null) {
            						current = createModelElement(grammarAccess.getTimingSettingsMapEntryRule());
            					}
            				
            otherlv_0=(Token)match(input,RULE_ID,FOLLOW_20); 

            					newLeafNode(otherlv_0, grammarAccess.getTimingSettingsMapEntryAccess().getKeyActionTypeCrossReference_0_0());
            				

            }


            }

            otherlv_1=(Token)match(input,20,FOLLOW_22); 

            			newLeafNode(otherlv_1, grammarAccess.getTimingSettingsMapEntryAccess().getEqualsSignKeyword_1());
            		
            // InternalSetting.g:700:3: ( (lv_value_2_0= ruleTiming ) )
            // InternalSetting.g:701:4: (lv_value_2_0= ruleTiming )
            {
            // InternalSetting.g:701:4: (lv_value_2_0= ruleTiming )
            // InternalSetting.g:702:5: lv_value_2_0= ruleTiming
            {

            					newCompositeNode(grammarAccess.getTimingSettingsMapEntryAccess().getValueTimingParserRuleCall_2_0());
            				
            pushFollow(FOLLOW_2);
            lv_value_2_0=ruleTiming();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getTimingSettingsMapEntryRule());
            					}
            					set(
            						current,
            						"value",
            						lv_value_2_0,
            						"org.eclipse.lsat.setting.teditor.Setting.Timing");
            					afterParserOrEnumRuleCall();
            				

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleTimingSettingsMapEntry"


    // $ANTLR start "entryRuleMotionProfileSettings"
    // InternalSetting.g:723:1: entryRuleMotionProfileSettings returns [EObject current=null] : iv_ruleMotionProfileSettings= ruleMotionProfileSettings EOF ;
    public final EObject entryRuleMotionProfileSettings() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleMotionProfileSettings = null;


        try {
            // InternalSetting.g:723:62: (iv_ruleMotionProfileSettings= ruleMotionProfileSettings EOF )
            // InternalSetting.g:724:2: iv_ruleMotionProfileSettings= ruleMotionProfileSettings EOF
            {
             newCompositeNode(grammarAccess.getMotionProfileSettingsRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleMotionProfileSettings=ruleMotionProfileSettings();

            state._fsp--;

             current =iv_ruleMotionProfileSettings; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleMotionProfileSettings"


    // $ANTLR start "ruleMotionProfileSettings"
    // InternalSetting.g:730:1: ruleMotionProfileSettings returns [EObject current=null] : ( () ( (lv_motionProfile_1_0= RULE_ID ) )? otherlv_2= '(' ( ( (lv_motionArguments_3_0= ruleMotionArgumentsMapEntry ) ) (otherlv_4= ',' ( (lv_motionArguments_5_0= ruleMotionArgumentsMapEntry ) ) )* )? otherlv_6= ')' ) ;
    public final EObject ruleMotionProfileSettings() throws RecognitionException {
        EObject current = null;

        Token lv_motionProfile_1_0=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_6=null;
        EObject lv_motionArguments_3_0 = null;

        EObject lv_motionArguments_5_0 = null;



        	enterRule();

        try {
            // InternalSetting.g:736:2: ( ( () ( (lv_motionProfile_1_0= RULE_ID ) )? otherlv_2= '(' ( ( (lv_motionArguments_3_0= ruleMotionArgumentsMapEntry ) ) (otherlv_4= ',' ( (lv_motionArguments_5_0= ruleMotionArgumentsMapEntry ) ) )* )? otherlv_6= ')' ) )
            // InternalSetting.g:737:2: ( () ( (lv_motionProfile_1_0= RULE_ID ) )? otherlv_2= '(' ( ( (lv_motionArguments_3_0= ruleMotionArgumentsMapEntry ) ) (otherlv_4= ',' ( (lv_motionArguments_5_0= ruleMotionArgumentsMapEntry ) ) )* )? otherlv_6= ')' )
            {
            // InternalSetting.g:737:2: ( () ( (lv_motionProfile_1_0= RULE_ID ) )? otherlv_2= '(' ( ( (lv_motionArguments_3_0= ruleMotionArgumentsMapEntry ) ) (otherlv_4= ',' ( (lv_motionArguments_5_0= ruleMotionArgumentsMapEntry ) ) )* )? otherlv_6= ')' )
            // InternalSetting.g:738:3: () ( (lv_motionProfile_1_0= RULE_ID ) )? otherlv_2= '(' ( ( (lv_motionArguments_3_0= ruleMotionArgumentsMapEntry ) ) (otherlv_4= ',' ( (lv_motionArguments_5_0= ruleMotionArgumentsMapEntry ) ) )* )? otherlv_6= ')'
            {
            // InternalSetting.g:738:3: ()
            // InternalSetting.g:739:4: 
            {

            				current = forceCreateModelElement(
            					grammarAccess.getMotionProfileSettingsAccess().getMotionProfileSettingsAction_0(),
            					current);
            			

            }

            // InternalSetting.g:745:3: ( (lv_motionProfile_1_0= RULE_ID ) )?
            int alt12=2;
            int LA12_0 = input.LA(1);

            if ( (LA12_0==RULE_ID) ) {
                alt12=1;
            }
            switch (alt12) {
                case 1 :
                    // InternalSetting.g:746:4: (lv_motionProfile_1_0= RULE_ID )
                    {
                    // InternalSetting.g:746:4: (lv_motionProfile_1_0= RULE_ID )
                    // InternalSetting.g:747:5: lv_motionProfile_1_0= RULE_ID
                    {
                    lv_motionProfile_1_0=(Token)match(input,RULE_ID,FOLLOW_23); 

                    					newLeafNode(lv_motionProfile_1_0, grammarAccess.getMotionProfileSettingsAccess().getMotionProfileIDTerminalRuleCall_1_0());
                    				

                    					if (current==null) {
                    						current = createModelElement(grammarAccess.getMotionProfileSettingsRule());
                    					}
                    					setWithLastConsumed(
                    						current,
                    						"motionProfile",
                    						lv_motionProfile_1_0,
                    						"org.eclipse.xtext.common.Terminals.ID");
                    				

                    }


                    }
                    break;

            }

            otherlv_2=(Token)match(input,21,FOLLOW_24); 

            			newLeafNode(otherlv_2, grammarAccess.getMotionProfileSettingsAccess().getLeftParenthesisKeyword_2());
            		
            // InternalSetting.g:767:3: ( ( (lv_motionArguments_3_0= ruleMotionArgumentsMapEntry ) ) (otherlv_4= ',' ( (lv_motionArguments_5_0= ruleMotionArgumentsMapEntry ) ) )* )?
            int alt14=2;
            int LA14_0 = input.LA(1);

            if ( (LA14_0==RULE_ID) ) {
                alt14=1;
            }
            switch (alt14) {
                case 1 :
                    // InternalSetting.g:768:4: ( (lv_motionArguments_3_0= ruleMotionArgumentsMapEntry ) ) (otherlv_4= ',' ( (lv_motionArguments_5_0= ruleMotionArgumentsMapEntry ) ) )*
                    {
                    // InternalSetting.g:768:4: ( (lv_motionArguments_3_0= ruleMotionArgumentsMapEntry ) )
                    // InternalSetting.g:769:5: (lv_motionArguments_3_0= ruleMotionArgumentsMapEntry )
                    {
                    // InternalSetting.g:769:5: (lv_motionArguments_3_0= ruleMotionArgumentsMapEntry )
                    // InternalSetting.g:770:6: lv_motionArguments_3_0= ruleMotionArgumentsMapEntry
                    {

                    						newCompositeNode(grammarAccess.getMotionProfileSettingsAccess().getMotionArgumentsMotionArgumentsMapEntryParserRuleCall_3_0_0());
                    					
                    pushFollow(FOLLOW_25);
                    lv_motionArguments_3_0=ruleMotionArgumentsMapEntry();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getMotionProfileSettingsRule());
                    						}
                    						add(
                    							current,
                    							"motionArguments",
                    							lv_motionArguments_3_0,
                    							"org.eclipse.lsat.setting.teditor.Setting.MotionArgumentsMapEntry");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }

                    // InternalSetting.g:787:4: (otherlv_4= ',' ( (lv_motionArguments_5_0= ruleMotionArgumentsMapEntry ) ) )*
                    loop13:
                    do {
                        int alt13=2;
                        int LA13_0 = input.LA(1);

                        if ( (LA13_0==22) ) {
                            alt13=1;
                        }


                        switch (alt13) {
                    	case 1 :
                    	    // InternalSetting.g:788:5: otherlv_4= ',' ( (lv_motionArguments_5_0= ruleMotionArgumentsMapEntry ) )
                    	    {
                    	    otherlv_4=(Token)match(input,22,FOLLOW_13); 

                    	    					newLeafNode(otherlv_4, grammarAccess.getMotionProfileSettingsAccess().getCommaKeyword_3_1_0());
                    	    				
                    	    // InternalSetting.g:792:5: ( (lv_motionArguments_5_0= ruleMotionArgumentsMapEntry ) )
                    	    // InternalSetting.g:793:6: (lv_motionArguments_5_0= ruleMotionArgumentsMapEntry )
                    	    {
                    	    // InternalSetting.g:793:6: (lv_motionArguments_5_0= ruleMotionArgumentsMapEntry )
                    	    // InternalSetting.g:794:7: lv_motionArguments_5_0= ruleMotionArgumentsMapEntry
                    	    {

                    	    							newCompositeNode(grammarAccess.getMotionProfileSettingsAccess().getMotionArgumentsMotionArgumentsMapEntryParserRuleCall_3_1_1_0());
                    	    						
                    	    pushFollow(FOLLOW_25);
                    	    lv_motionArguments_5_0=ruleMotionArgumentsMapEntry();

                    	    state._fsp--;


                    	    							if (current==null) {
                    	    								current = createModelElementForParent(grammarAccess.getMotionProfileSettingsRule());
                    	    							}
                    	    							add(
                    	    								current,
                    	    								"motionArguments",
                    	    								lv_motionArguments_5_0,
                    	    								"org.eclipse.lsat.setting.teditor.Setting.MotionArgumentsMapEntry");
                    	    							afterParserOrEnumRuleCall();
                    	    						

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop13;
                        }
                    } while (true);


                    }
                    break;

            }

            otherlv_6=(Token)match(input,23,FOLLOW_2); 

            			newLeafNode(otherlv_6, grammarAccess.getMotionProfileSettingsAccess().getRightParenthesisKeyword_4());
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleMotionProfileSettings"


    // $ANTLR start "entryRuleMotionArgumentsMapEntry"
    // InternalSetting.g:821:1: entryRuleMotionArgumentsMapEntry returns [EObject current=null] : iv_ruleMotionArgumentsMapEntry= ruleMotionArgumentsMapEntry EOF ;
    public final EObject entryRuleMotionArgumentsMapEntry() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleMotionArgumentsMapEntry = null;


        try {
            // InternalSetting.g:821:64: (iv_ruleMotionArgumentsMapEntry= ruleMotionArgumentsMapEntry EOF )
            // InternalSetting.g:822:2: iv_ruleMotionArgumentsMapEntry= ruleMotionArgumentsMapEntry EOF
            {
             newCompositeNode(grammarAccess.getMotionArgumentsMapEntryRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleMotionArgumentsMapEntry=ruleMotionArgumentsMapEntry();

            state._fsp--;

             current =iv_ruleMotionArgumentsMapEntry; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleMotionArgumentsMapEntry"


    // $ANTLR start "ruleMotionArgumentsMapEntry"
    // InternalSetting.g:828:1: ruleMotionArgumentsMapEntry returns [EObject current=null] : ( ( (lv_key_0_0= RULE_ID ) ) otherlv_1= '=' ( (lv_value_2_0= ruleExpression ) ) ) ;
    public final EObject ruleMotionArgumentsMapEntry() throws RecognitionException {
        EObject current = null;

        Token lv_key_0_0=null;
        Token otherlv_1=null;
        EObject lv_value_2_0 = null;



        	enterRule();

        try {
            // InternalSetting.g:834:2: ( ( ( (lv_key_0_0= RULE_ID ) ) otherlv_1= '=' ( (lv_value_2_0= ruleExpression ) ) ) )
            // InternalSetting.g:835:2: ( ( (lv_key_0_0= RULE_ID ) ) otherlv_1= '=' ( (lv_value_2_0= ruleExpression ) ) )
            {
            // InternalSetting.g:835:2: ( ( (lv_key_0_0= RULE_ID ) ) otherlv_1= '=' ( (lv_value_2_0= ruleExpression ) ) )
            // InternalSetting.g:836:3: ( (lv_key_0_0= RULE_ID ) ) otherlv_1= '=' ( (lv_value_2_0= ruleExpression ) )
            {
            // InternalSetting.g:836:3: ( (lv_key_0_0= RULE_ID ) )
            // InternalSetting.g:837:4: (lv_key_0_0= RULE_ID )
            {
            // InternalSetting.g:837:4: (lv_key_0_0= RULE_ID )
            // InternalSetting.g:838:5: lv_key_0_0= RULE_ID
            {
            lv_key_0_0=(Token)match(input,RULE_ID,FOLLOW_20); 

            					newLeafNode(lv_key_0_0, grammarAccess.getMotionArgumentsMapEntryAccess().getKeyIDTerminalRuleCall_0_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getMotionArgumentsMapEntryRule());
            					}
            					setWithLastConsumed(
            						current,
            						"key",
            						lv_key_0_0,
            						"org.eclipse.xtext.common.Terminals.ID");
            				

            }


            }

            otherlv_1=(Token)match(input,20,FOLLOW_21); 

            			newLeafNode(otherlv_1, grammarAccess.getMotionArgumentsMapEntryAccess().getEqualsSignKeyword_1());
            		
            // InternalSetting.g:858:3: ( (lv_value_2_0= ruleExpression ) )
            // InternalSetting.g:859:4: (lv_value_2_0= ruleExpression )
            {
            // InternalSetting.g:859:4: (lv_value_2_0= ruleExpression )
            // InternalSetting.g:860:5: lv_value_2_0= ruleExpression
            {

            					newCompositeNode(grammarAccess.getMotionArgumentsMapEntryAccess().getValueExpressionParserRuleCall_2_0());
            				
            pushFollow(FOLLOW_2);
            lv_value_2_0=ruleExpression();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getMotionArgumentsMapEntryRule());
            					}
            					set(
            						current,
            						"value",
            						lv_value_2_0,
            						"org.eclipse.lsat.setting.teditor.Setting.Expression");
            					afterParserOrEnumRuleCall();
            				

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleMotionArgumentsMapEntry"


    // $ANTLR start "entryRulePhysicalLocation"
    // InternalSetting.g:881:1: entryRulePhysicalLocation returns [EObject current=null] : iv_rulePhysicalLocation= rulePhysicalLocation EOF ;
    public final EObject entryRulePhysicalLocation() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePhysicalLocation = null;


        try {
            // InternalSetting.g:881:57: (iv_rulePhysicalLocation= rulePhysicalLocation EOF )
            // InternalSetting.g:882:2: iv_rulePhysicalLocation= rulePhysicalLocation EOF
            {
             newCompositeNode(grammarAccess.getPhysicalLocationRule()); 
            pushFollow(FOLLOW_1);
            iv_rulePhysicalLocation=rulePhysicalLocation();

            state._fsp--;

             current =iv_rulePhysicalLocation; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulePhysicalLocation"


    // $ANTLR start "rulePhysicalLocation"
    // InternalSetting.g:888:1: rulePhysicalLocation returns [EObject current=null] : ( (otherlv_0= '=' ( (lv_defaultExp_1_0= ruleExpression ) ) ) | (otherlv_2= '(' (otherlv_3= 'min' otherlv_4= '=' ( (lv_minExp_5_0= ruleExpression ) ) otherlv_6= ',' )? (otherlv_7= 'max' otherlv_8= '=' ( (lv_maxExp_9_0= ruleExpression ) ) otherlv_10= ',' )? otherlv_11= 'default' otherlv_12= '=' ( (lv_defaultExp_13_0= ruleExpression ) ) otherlv_14= ')' ) ) ;
    public final EObject rulePhysicalLocation() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_2=null;
        Token otherlv_3=null;
        Token otherlv_4=null;
        Token otherlv_6=null;
        Token otherlv_7=null;
        Token otherlv_8=null;
        Token otherlv_10=null;
        Token otherlv_11=null;
        Token otherlv_12=null;
        Token otherlv_14=null;
        EObject lv_defaultExp_1_0 = null;

        EObject lv_minExp_5_0 = null;

        EObject lv_maxExp_9_0 = null;

        EObject lv_defaultExp_13_0 = null;



        	enterRule();

        try {
            // InternalSetting.g:894:2: ( ( (otherlv_0= '=' ( (lv_defaultExp_1_0= ruleExpression ) ) ) | (otherlv_2= '(' (otherlv_3= 'min' otherlv_4= '=' ( (lv_minExp_5_0= ruleExpression ) ) otherlv_6= ',' )? (otherlv_7= 'max' otherlv_8= '=' ( (lv_maxExp_9_0= ruleExpression ) ) otherlv_10= ',' )? otherlv_11= 'default' otherlv_12= '=' ( (lv_defaultExp_13_0= ruleExpression ) ) otherlv_14= ')' ) ) )
            // InternalSetting.g:895:2: ( (otherlv_0= '=' ( (lv_defaultExp_1_0= ruleExpression ) ) ) | (otherlv_2= '(' (otherlv_3= 'min' otherlv_4= '=' ( (lv_minExp_5_0= ruleExpression ) ) otherlv_6= ',' )? (otherlv_7= 'max' otherlv_8= '=' ( (lv_maxExp_9_0= ruleExpression ) ) otherlv_10= ',' )? otherlv_11= 'default' otherlv_12= '=' ( (lv_defaultExp_13_0= ruleExpression ) ) otherlv_14= ')' ) )
            {
            // InternalSetting.g:895:2: ( (otherlv_0= '=' ( (lv_defaultExp_1_0= ruleExpression ) ) ) | (otherlv_2= '(' (otherlv_3= 'min' otherlv_4= '=' ( (lv_minExp_5_0= ruleExpression ) ) otherlv_6= ',' )? (otherlv_7= 'max' otherlv_8= '=' ( (lv_maxExp_9_0= ruleExpression ) ) otherlv_10= ',' )? otherlv_11= 'default' otherlv_12= '=' ( (lv_defaultExp_13_0= ruleExpression ) ) otherlv_14= ')' ) )
            int alt17=2;
            int LA17_0 = input.LA(1);

            if ( (LA17_0==20) ) {
                alt17=1;
            }
            else if ( (LA17_0==21) ) {
                alt17=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 17, 0, input);

                throw nvae;
            }
            switch (alt17) {
                case 1 :
                    // InternalSetting.g:896:3: (otherlv_0= '=' ( (lv_defaultExp_1_0= ruleExpression ) ) )
                    {
                    // InternalSetting.g:896:3: (otherlv_0= '=' ( (lv_defaultExp_1_0= ruleExpression ) ) )
                    // InternalSetting.g:897:4: otherlv_0= '=' ( (lv_defaultExp_1_0= ruleExpression ) )
                    {
                    otherlv_0=(Token)match(input,20,FOLLOW_21); 

                    				newLeafNode(otherlv_0, grammarAccess.getPhysicalLocationAccess().getEqualsSignKeyword_0_0());
                    			
                    // InternalSetting.g:901:4: ( (lv_defaultExp_1_0= ruleExpression ) )
                    // InternalSetting.g:902:5: (lv_defaultExp_1_0= ruleExpression )
                    {
                    // InternalSetting.g:902:5: (lv_defaultExp_1_0= ruleExpression )
                    // InternalSetting.g:903:6: lv_defaultExp_1_0= ruleExpression
                    {

                    						newCompositeNode(grammarAccess.getPhysicalLocationAccess().getDefaultExpExpressionParserRuleCall_0_1_0());
                    					
                    pushFollow(FOLLOW_2);
                    lv_defaultExp_1_0=ruleExpression();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getPhysicalLocationRule());
                    						}
                    						set(
                    							current,
                    							"defaultExp",
                    							lv_defaultExp_1_0,
                    							"org.eclipse.lsat.setting.teditor.Setting.Expression");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }


                    }


                    }
                    break;
                case 2 :
                    // InternalSetting.g:922:3: (otherlv_2= '(' (otherlv_3= 'min' otherlv_4= '=' ( (lv_minExp_5_0= ruleExpression ) ) otherlv_6= ',' )? (otherlv_7= 'max' otherlv_8= '=' ( (lv_maxExp_9_0= ruleExpression ) ) otherlv_10= ',' )? otherlv_11= 'default' otherlv_12= '=' ( (lv_defaultExp_13_0= ruleExpression ) ) otherlv_14= ')' )
                    {
                    // InternalSetting.g:922:3: (otherlv_2= '(' (otherlv_3= 'min' otherlv_4= '=' ( (lv_minExp_5_0= ruleExpression ) ) otherlv_6= ',' )? (otherlv_7= 'max' otherlv_8= '=' ( (lv_maxExp_9_0= ruleExpression ) ) otherlv_10= ',' )? otherlv_11= 'default' otherlv_12= '=' ( (lv_defaultExp_13_0= ruleExpression ) ) otherlv_14= ')' )
                    // InternalSetting.g:923:4: otherlv_2= '(' (otherlv_3= 'min' otherlv_4= '=' ( (lv_minExp_5_0= ruleExpression ) ) otherlv_6= ',' )? (otherlv_7= 'max' otherlv_8= '=' ( (lv_maxExp_9_0= ruleExpression ) ) otherlv_10= ',' )? otherlv_11= 'default' otherlv_12= '=' ( (lv_defaultExp_13_0= ruleExpression ) ) otherlv_14= ')'
                    {
                    otherlv_2=(Token)match(input,21,FOLLOW_26); 

                    				newLeafNode(otherlv_2, grammarAccess.getPhysicalLocationAccess().getLeftParenthesisKeyword_1_0());
                    			
                    // InternalSetting.g:927:4: (otherlv_3= 'min' otherlv_4= '=' ( (lv_minExp_5_0= ruleExpression ) ) otherlv_6= ',' )?
                    int alt15=2;
                    int LA15_0 = input.LA(1);

                    if ( (LA15_0==24) ) {
                        alt15=1;
                    }
                    switch (alt15) {
                        case 1 :
                            // InternalSetting.g:928:5: otherlv_3= 'min' otherlv_4= '=' ( (lv_minExp_5_0= ruleExpression ) ) otherlv_6= ','
                            {
                            otherlv_3=(Token)match(input,24,FOLLOW_20); 

                            					newLeafNode(otherlv_3, grammarAccess.getPhysicalLocationAccess().getMinKeyword_1_1_0());
                            				
                            otherlv_4=(Token)match(input,20,FOLLOW_21); 

                            					newLeafNode(otherlv_4, grammarAccess.getPhysicalLocationAccess().getEqualsSignKeyword_1_1_1());
                            				
                            // InternalSetting.g:936:5: ( (lv_minExp_5_0= ruleExpression ) )
                            // InternalSetting.g:937:6: (lv_minExp_5_0= ruleExpression )
                            {
                            // InternalSetting.g:937:6: (lv_minExp_5_0= ruleExpression )
                            // InternalSetting.g:938:7: lv_minExp_5_0= ruleExpression
                            {

                            							newCompositeNode(grammarAccess.getPhysicalLocationAccess().getMinExpExpressionParserRuleCall_1_1_2_0());
                            						
                            pushFollow(FOLLOW_27);
                            lv_minExp_5_0=ruleExpression();

                            state._fsp--;


                            							if (current==null) {
                            								current = createModelElementForParent(grammarAccess.getPhysicalLocationRule());
                            							}
                            							set(
                            								current,
                            								"minExp",
                            								lv_minExp_5_0,
                            								"org.eclipse.lsat.setting.teditor.Setting.Expression");
                            							afterParserOrEnumRuleCall();
                            						

                            }


                            }

                            otherlv_6=(Token)match(input,22,FOLLOW_28); 

                            					newLeafNode(otherlv_6, grammarAccess.getPhysicalLocationAccess().getCommaKeyword_1_1_3());
                            				

                            }
                            break;

                    }

                    // InternalSetting.g:960:4: (otherlv_7= 'max' otherlv_8= '=' ( (lv_maxExp_9_0= ruleExpression ) ) otherlv_10= ',' )?
                    int alt16=2;
                    int LA16_0 = input.LA(1);

                    if ( (LA16_0==25) ) {
                        alt16=1;
                    }
                    switch (alt16) {
                        case 1 :
                            // InternalSetting.g:961:5: otherlv_7= 'max' otherlv_8= '=' ( (lv_maxExp_9_0= ruleExpression ) ) otherlv_10= ','
                            {
                            otherlv_7=(Token)match(input,25,FOLLOW_20); 

                            					newLeafNode(otherlv_7, grammarAccess.getPhysicalLocationAccess().getMaxKeyword_1_2_0());
                            				
                            otherlv_8=(Token)match(input,20,FOLLOW_21); 

                            					newLeafNode(otherlv_8, grammarAccess.getPhysicalLocationAccess().getEqualsSignKeyword_1_2_1());
                            				
                            // InternalSetting.g:969:5: ( (lv_maxExp_9_0= ruleExpression ) )
                            // InternalSetting.g:970:6: (lv_maxExp_9_0= ruleExpression )
                            {
                            // InternalSetting.g:970:6: (lv_maxExp_9_0= ruleExpression )
                            // InternalSetting.g:971:7: lv_maxExp_9_0= ruleExpression
                            {

                            							newCompositeNode(grammarAccess.getPhysicalLocationAccess().getMaxExpExpressionParserRuleCall_1_2_2_0());
                            						
                            pushFollow(FOLLOW_27);
                            lv_maxExp_9_0=ruleExpression();

                            state._fsp--;


                            							if (current==null) {
                            								current = createModelElementForParent(grammarAccess.getPhysicalLocationRule());
                            							}
                            							set(
                            								current,
                            								"maxExp",
                            								lv_maxExp_9_0,
                            								"org.eclipse.lsat.setting.teditor.Setting.Expression");
                            							afterParserOrEnumRuleCall();
                            						

                            }


                            }

                            otherlv_10=(Token)match(input,22,FOLLOW_29); 

                            					newLeafNode(otherlv_10, grammarAccess.getPhysicalLocationAccess().getCommaKeyword_1_2_3());
                            				

                            }
                            break;

                    }

                    otherlv_11=(Token)match(input,26,FOLLOW_20); 

                    				newLeafNode(otherlv_11, grammarAccess.getPhysicalLocationAccess().getDefaultKeyword_1_3());
                    			
                    otherlv_12=(Token)match(input,20,FOLLOW_21); 

                    				newLeafNode(otherlv_12, grammarAccess.getPhysicalLocationAccess().getEqualsSignKeyword_1_4());
                    			
                    // InternalSetting.g:1001:4: ( (lv_defaultExp_13_0= ruleExpression ) )
                    // InternalSetting.g:1002:5: (lv_defaultExp_13_0= ruleExpression )
                    {
                    // InternalSetting.g:1002:5: (lv_defaultExp_13_0= ruleExpression )
                    // InternalSetting.g:1003:6: lv_defaultExp_13_0= ruleExpression
                    {

                    						newCompositeNode(grammarAccess.getPhysicalLocationAccess().getDefaultExpExpressionParserRuleCall_1_5_0());
                    					
                    pushFollow(FOLLOW_30);
                    lv_defaultExp_13_0=ruleExpression();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getPhysicalLocationRule());
                    						}
                    						set(
                    							current,
                    							"defaultExp",
                    							lv_defaultExp_13_0,
                    							"org.eclipse.lsat.setting.teditor.Setting.Expression");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }

                    otherlv_14=(Token)match(input,23,FOLLOW_2); 

                    				newLeafNode(otherlv_14, grammarAccess.getPhysicalLocationAccess().getRightParenthesisKeyword_1_6());
                    			

                    }


                    }
                    break;

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "rulePhysicalLocation"


    // $ANTLR start "entryRuleTiming"
    // InternalSetting.g:1029:1: entryRuleTiming returns [EObject current=null] : iv_ruleTiming= ruleTiming EOF ;
    public final EObject entryRuleTiming() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleTiming = null;


        try {
            // InternalSetting.g:1029:47: (iv_ruleTiming= ruleTiming EOF )
            // InternalSetting.g:1030:2: iv_ruleTiming= ruleTiming EOF
            {
             newCompositeNode(grammarAccess.getTimingRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleTiming=ruleTiming();

            state._fsp--;

             current =iv_ruleTiming; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleTiming"


    // $ANTLR start "ruleTiming"
    // InternalSetting.g:1036:1: ruleTiming returns [EObject current=null] : (this_FixedValue_0= ruleFixedValue | this_Array_1= ruleArray | this_TriangularDistribution_2= ruleTriangularDistribution | this_PertDistribution_3= rulePertDistribution | this_NormalDistribution_4= ruleNormalDistribution | this_EnumeratedDistribution_5= ruleEnumeratedDistribution ) ;
    public final EObject ruleTiming() throws RecognitionException {
        EObject current = null;

        EObject this_FixedValue_0 = null;

        EObject this_Array_1 = null;

        EObject this_TriangularDistribution_2 = null;

        EObject this_PertDistribution_3 = null;

        EObject this_NormalDistribution_4 = null;

        EObject this_EnumeratedDistribution_5 = null;



        	enterRule();

        try {
            // InternalSetting.g:1042:2: ( (this_FixedValue_0= ruleFixedValue | this_Array_1= ruleArray | this_TriangularDistribution_2= ruleTriangularDistribution | this_PertDistribution_3= rulePertDistribution | this_NormalDistribution_4= ruleNormalDistribution | this_EnumeratedDistribution_5= ruleEnumeratedDistribution ) )
            // InternalSetting.g:1043:2: (this_FixedValue_0= ruleFixedValue | this_Array_1= ruleArray | this_TriangularDistribution_2= ruleTriangularDistribution | this_PertDistribution_3= rulePertDistribution | this_NormalDistribution_4= ruleNormalDistribution | this_EnumeratedDistribution_5= ruleEnumeratedDistribution )
            {
            // InternalSetting.g:1043:2: (this_FixedValue_0= ruleFixedValue | this_Array_1= ruleArray | this_TriangularDistribution_2= ruleTriangularDistribution | this_PertDistribution_3= rulePertDistribution | this_NormalDistribution_4= ruleNormalDistribution | this_EnumeratedDistribution_5= ruleEnumeratedDistribution )
            int alt18=6;
            switch ( input.LA(1) ) {
            case RULE_ID:
            case RULE_INT:
            case 21:
            case 38:
                {
                alt18=1;
                }
                break;
            case 27:
                {
                alt18=2;
                }
                break;
            case 28:
                {
                alt18=3;
                }
                break;
            case 30:
                {
                alt18=4;
                }
                break;
            case 32:
                {
                alt18=5;
                }
                break;
            case 35:
                {
                alt18=6;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 18, 0, input);

                throw nvae;
            }

            switch (alt18) {
                case 1 :
                    // InternalSetting.g:1044:3: this_FixedValue_0= ruleFixedValue
                    {

                    			newCompositeNode(grammarAccess.getTimingAccess().getFixedValueParserRuleCall_0());
                    		
                    pushFollow(FOLLOW_2);
                    this_FixedValue_0=ruleFixedValue();

                    state._fsp--;


                    			current = this_FixedValue_0;
                    			afterParserOrEnumRuleCall();
                    		

                    }
                    break;
                case 2 :
                    // InternalSetting.g:1053:3: this_Array_1= ruleArray
                    {

                    			newCompositeNode(grammarAccess.getTimingAccess().getArrayParserRuleCall_1());
                    		
                    pushFollow(FOLLOW_2);
                    this_Array_1=ruleArray();

                    state._fsp--;


                    			current = this_Array_1;
                    			afterParserOrEnumRuleCall();
                    		

                    }
                    break;
                case 3 :
                    // InternalSetting.g:1062:3: this_TriangularDistribution_2= ruleTriangularDistribution
                    {

                    			newCompositeNode(grammarAccess.getTimingAccess().getTriangularDistributionParserRuleCall_2());
                    		
                    pushFollow(FOLLOW_2);
                    this_TriangularDistribution_2=ruleTriangularDistribution();

                    state._fsp--;


                    			current = this_TriangularDistribution_2;
                    			afterParserOrEnumRuleCall();
                    		

                    }
                    break;
                case 4 :
                    // InternalSetting.g:1071:3: this_PertDistribution_3= rulePertDistribution
                    {

                    			newCompositeNode(grammarAccess.getTimingAccess().getPertDistributionParserRuleCall_3());
                    		
                    pushFollow(FOLLOW_2);
                    this_PertDistribution_3=rulePertDistribution();

                    state._fsp--;


                    			current = this_PertDistribution_3;
                    			afterParserOrEnumRuleCall();
                    		

                    }
                    break;
                case 5 :
                    // InternalSetting.g:1080:3: this_NormalDistribution_4= ruleNormalDistribution
                    {

                    			newCompositeNode(grammarAccess.getTimingAccess().getNormalDistributionParserRuleCall_4());
                    		
                    pushFollow(FOLLOW_2);
                    this_NormalDistribution_4=ruleNormalDistribution();

                    state._fsp--;


                    			current = this_NormalDistribution_4;
                    			afterParserOrEnumRuleCall();
                    		

                    }
                    break;
                case 6 :
                    // InternalSetting.g:1089:3: this_EnumeratedDistribution_5= ruleEnumeratedDistribution
                    {

                    			newCompositeNode(grammarAccess.getTimingAccess().getEnumeratedDistributionParserRuleCall_5());
                    		
                    pushFollow(FOLLOW_2);
                    this_EnumeratedDistribution_5=ruleEnumeratedDistribution();

                    state._fsp--;


                    			current = this_EnumeratedDistribution_5;
                    			afterParserOrEnumRuleCall();
                    		

                    }
                    break;

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleTiming"


    // $ANTLR start "entryRuleFixedValue"
    // InternalSetting.g:1101:1: entryRuleFixedValue returns [EObject current=null] : iv_ruleFixedValue= ruleFixedValue EOF ;
    public final EObject entryRuleFixedValue() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleFixedValue = null;


        try {
            // InternalSetting.g:1101:51: (iv_ruleFixedValue= ruleFixedValue EOF )
            // InternalSetting.g:1102:2: iv_ruleFixedValue= ruleFixedValue EOF
            {
             newCompositeNode(grammarAccess.getFixedValueRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleFixedValue=ruleFixedValue();

            state._fsp--;

             current =iv_ruleFixedValue; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleFixedValue"


    // $ANTLR start "ruleFixedValue"
    // InternalSetting.g:1108:1: ruleFixedValue returns [EObject current=null] : ( (lv_valueExp_0_0= ruleExpression ) ) ;
    public final EObject ruleFixedValue() throws RecognitionException {
        EObject current = null;

        EObject lv_valueExp_0_0 = null;



        	enterRule();

        try {
            // InternalSetting.g:1114:2: ( ( (lv_valueExp_0_0= ruleExpression ) ) )
            // InternalSetting.g:1115:2: ( (lv_valueExp_0_0= ruleExpression ) )
            {
            // InternalSetting.g:1115:2: ( (lv_valueExp_0_0= ruleExpression ) )
            // InternalSetting.g:1116:3: (lv_valueExp_0_0= ruleExpression )
            {
            // InternalSetting.g:1116:3: (lv_valueExp_0_0= ruleExpression )
            // InternalSetting.g:1117:4: lv_valueExp_0_0= ruleExpression
            {

            				newCompositeNode(grammarAccess.getFixedValueAccess().getValueExpExpressionParserRuleCall_0());
            			
            pushFollow(FOLLOW_2);
            lv_valueExp_0_0=ruleExpression();

            state._fsp--;


            				if (current==null) {
            					current = createModelElementForParent(grammarAccess.getFixedValueRule());
            				}
            				set(
            					current,
            					"valueExp",
            					lv_valueExp_0_0,
            					"org.eclipse.lsat.setting.teditor.Setting.Expression");
            				afterParserOrEnumRuleCall();
            			

            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleFixedValue"


    // $ANTLR start "entryRuleArray"
    // InternalSetting.g:1137:1: entryRuleArray returns [EObject current=null] : iv_ruleArray= ruleArray EOF ;
    public final EObject entryRuleArray() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleArray = null;


        try {
            // InternalSetting.g:1137:46: (iv_ruleArray= ruleArray EOF )
            // InternalSetting.g:1138:2: iv_ruleArray= ruleArray EOF
            {
             newCompositeNode(grammarAccess.getArrayRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleArray=ruleArray();

            state._fsp--;

             current =iv_ruleArray; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleArray"


    // $ANTLR start "ruleArray"
    // InternalSetting.g:1144:1: ruleArray returns [EObject current=null] : (otherlv_0= 'Array' otherlv_1= '(' ( (lv_valuesExp_2_0= ruleExpression ) ) (otherlv_3= ',' ( (lv_valuesExp_4_0= ruleExpression ) ) )* otherlv_5= ')' ) ;
    public final EObject ruleArray() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_1=null;
        Token otherlv_3=null;
        Token otherlv_5=null;
        EObject lv_valuesExp_2_0 = null;

        EObject lv_valuesExp_4_0 = null;



        	enterRule();

        try {
            // InternalSetting.g:1150:2: ( (otherlv_0= 'Array' otherlv_1= '(' ( (lv_valuesExp_2_0= ruleExpression ) ) (otherlv_3= ',' ( (lv_valuesExp_4_0= ruleExpression ) ) )* otherlv_5= ')' ) )
            // InternalSetting.g:1151:2: (otherlv_0= 'Array' otherlv_1= '(' ( (lv_valuesExp_2_0= ruleExpression ) ) (otherlv_3= ',' ( (lv_valuesExp_4_0= ruleExpression ) ) )* otherlv_5= ')' )
            {
            // InternalSetting.g:1151:2: (otherlv_0= 'Array' otherlv_1= '(' ( (lv_valuesExp_2_0= ruleExpression ) ) (otherlv_3= ',' ( (lv_valuesExp_4_0= ruleExpression ) ) )* otherlv_5= ')' )
            // InternalSetting.g:1152:3: otherlv_0= 'Array' otherlv_1= '(' ( (lv_valuesExp_2_0= ruleExpression ) ) (otherlv_3= ',' ( (lv_valuesExp_4_0= ruleExpression ) ) )* otherlv_5= ')'
            {
            otherlv_0=(Token)match(input,27,FOLLOW_23); 

            			newLeafNode(otherlv_0, grammarAccess.getArrayAccess().getArrayKeyword_0());
            		
            otherlv_1=(Token)match(input,21,FOLLOW_21); 

            			newLeafNode(otherlv_1, grammarAccess.getArrayAccess().getLeftParenthesisKeyword_1());
            		
            // InternalSetting.g:1160:3: ( (lv_valuesExp_2_0= ruleExpression ) )
            // InternalSetting.g:1161:4: (lv_valuesExp_2_0= ruleExpression )
            {
            // InternalSetting.g:1161:4: (lv_valuesExp_2_0= ruleExpression )
            // InternalSetting.g:1162:5: lv_valuesExp_2_0= ruleExpression
            {

            					newCompositeNode(grammarAccess.getArrayAccess().getValuesExpExpressionParserRuleCall_2_0());
            				
            pushFollow(FOLLOW_25);
            lv_valuesExp_2_0=ruleExpression();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getArrayRule());
            					}
            					add(
            						current,
            						"valuesExp",
            						lv_valuesExp_2_0,
            						"org.eclipse.lsat.setting.teditor.Setting.Expression");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalSetting.g:1179:3: (otherlv_3= ',' ( (lv_valuesExp_4_0= ruleExpression ) ) )*
            loop19:
            do {
                int alt19=2;
                int LA19_0 = input.LA(1);

                if ( (LA19_0==22) ) {
                    alt19=1;
                }


                switch (alt19) {
            	case 1 :
            	    // InternalSetting.g:1180:4: otherlv_3= ',' ( (lv_valuesExp_4_0= ruleExpression ) )
            	    {
            	    otherlv_3=(Token)match(input,22,FOLLOW_21); 

            	    				newLeafNode(otherlv_3, grammarAccess.getArrayAccess().getCommaKeyword_3_0());
            	    			
            	    // InternalSetting.g:1184:4: ( (lv_valuesExp_4_0= ruleExpression ) )
            	    // InternalSetting.g:1185:5: (lv_valuesExp_4_0= ruleExpression )
            	    {
            	    // InternalSetting.g:1185:5: (lv_valuesExp_4_0= ruleExpression )
            	    // InternalSetting.g:1186:6: lv_valuesExp_4_0= ruleExpression
            	    {

            	    						newCompositeNode(grammarAccess.getArrayAccess().getValuesExpExpressionParserRuleCall_3_1_0());
            	    					
            	    pushFollow(FOLLOW_25);
            	    lv_valuesExp_4_0=ruleExpression();

            	    state._fsp--;


            	    						if (current==null) {
            	    							current = createModelElementForParent(grammarAccess.getArrayRule());
            	    						}
            	    						add(
            	    							current,
            	    							"valuesExp",
            	    							lv_valuesExp_4_0,
            	    							"org.eclipse.lsat.setting.teditor.Setting.Expression");
            	    						afterParserOrEnumRuleCall();
            	    					

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop19;
                }
            } while (true);

            otherlv_5=(Token)match(input,23,FOLLOW_2); 

            			newLeafNode(otherlv_5, grammarAccess.getArrayAccess().getRightParenthesisKeyword_4());
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleArray"


    // $ANTLR start "entryRuleTriangularDistribution"
    // InternalSetting.g:1212:1: entryRuleTriangularDistribution returns [EObject current=null] : iv_ruleTriangularDistribution= ruleTriangularDistribution EOF ;
    public final EObject entryRuleTriangularDistribution() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleTriangularDistribution = null;


        try {
            // InternalSetting.g:1212:63: (iv_ruleTriangularDistribution= ruleTriangularDistribution EOF )
            // InternalSetting.g:1213:2: iv_ruleTriangularDistribution= ruleTriangularDistribution EOF
            {
             newCompositeNode(grammarAccess.getTriangularDistributionRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleTriangularDistribution=ruleTriangularDistribution();

            state._fsp--;

             current =iv_ruleTriangularDistribution; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleTriangularDistribution"


    // $ANTLR start "ruleTriangularDistribution"
    // InternalSetting.g:1219:1: ruleTriangularDistribution returns [EObject current=null] : (otherlv_0= 'Triangular' otherlv_1= '(' otherlv_2= 'min' otherlv_3= '=' ( (lv_minExp_4_0= ruleExpression ) ) otherlv_5= ',' otherlv_6= 'max' otherlv_7= '=' ( (lv_maxExp_8_0= ruleExpression ) ) otherlv_9= ',' otherlv_10= 'mode' otherlv_11= '=' ( (lv_modeExp_12_0= ruleExpression ) ) (otherlv_13= ',' otherlv_14= 'default' otherlv_15= '=' ( (lv_defaultExp_16_0= ruleExpression ) ) )? otherlv_17= ')' ) ;
    public final EObject ruleTriangularDistribution() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_1=null;
        Token otherlv_2=null;
        Token otherlv_3=null;
        Token otherlv_5=null;
        Token otherlv_6=null;
        Token otherlv_7=null;
        Token otherlv_9=null;
        Token otherlv_10=null;
        Token otherlv_11=null;
        Token otherlv_13=null;
        Token otherlv_14=null;
        Token otherlv_15=null;
        Token otherlv_17=null;
        EObject lv_minExp_4_0 = null;

        EObject lv_maxExp_8_0 = null;

        EObject lv_modeExp_12_0 = null;

        EObject lv_defaultExp_16_0 = null;



        	enterRule();

        try {
            // InternalSetting.g:1225:2: ( (otherlv_0= 'Triangular' otherlv_1= '(' otherlv_2= 'min' otherlv_3= '=' ( (lv_minExp_4_0= ruleExpression ) ) otherlv_5= ',' otherlv_6= 'max' otherlv_7= '=' ( (lv_maxExp_8_0= ruleExpression ) ) otherlv_9= ',' otherlv_10= 'mode' otherlv_11= '=' ( (lv_modeExp_12_0= ruleExpression ) ) (otherlv_13= ',' otherlv_14= 'default' otherlv_15= '=' ( (lv_defaultExp_16_0= ruleExpression ) ) )? otherlv_17= ')' ) )
            // InternalSetting.g:1226:2: (otherlv_0= 'Triangular' otherlv_1= '(' otherlv_2= 'min' otherlv_3= '=' ( (lv_minExp_4_0= ruleExpression ) ) otherlv_5= ',' otherlv_6= 'max' otherlv_7= '=' ( (lv_maxExp_8_0= ruleExpression ) ) otherlv_9= ',' otherlv_10= 'mode' otherlv_11= '=' ( (lv_modeExp_12_0= ruleExpression ) ) (otherlv_13= ',' otherlv_14= 'default' otherlv_15= '=' ( (lv_defaultExp_16_0= ruleExpression ) ) )? otherlv_17= ')' )
            {
            // InternalSetting.g:1226:2: (otherlv_0= 'Triangular' otherlv_1= '(' otherlv_2= 'min' otherlv_3= '=' ( (lv_minExp_4_0= ruleExpression ) ) otherlv_5= ',' otherlv_6= 'max' otherlv_7= '=' ( (lv_maxExp_8_0= ruleExpression ) ) otherlv_9= ',' otherlv_10= 'mode' otherlv_11= '=' ( (lv_modeExp_12_0= ruleExpression ) ) (otherlv_13= ',' otherlv_14= 'default' otherlv_15= '=' ( (lv_defaultExp_16_0= ruleExpression ) ) )? otherlv_17= ')' )
            // InternalSetting.g:1227:3: otherlv_0= 'Triangular' otherlv_1= '(' otherlv_2= 'min' otherlv_3= '=' ( (lv_minExp_4_0= ruleExpression ) ) otherlv_5= ',' otherlv_6= 'max' otherlv_7= '=' ( (lv_maxExp_8_0= ruleExpression ) ) otherlv_9= ',' otherlv_10= 'mode' otherlv_11= '=' ( (lv_modeExp_12_0= ruleExpression ) ) (otherlv_13= ',' otherlv_14= 'default' otherlv_15= '=' ( (lv_defaultExp_16_0= ruleExpression ) ) )? otherlv_17= ')'
            {
            otherlv_0=(Token)match(input,28,FOLLOW_23); 

            			newLeafNode(otherlv_0, grammarAccess.getTriangularDistributionAccess().getTriangularKeyword_0());
            		
            otherlv_1=(Token)match(input,21,FOLLOW_31); 

            			newLeafNode(otherlv_1, grammarAccess.getTriangularDistributionAccess().getLeftParenthesisKeyword_1());
            		
            otherlv_2=(Token)match(input,24,FOLLOW_20); 

            			newLeafNode(otherlv_2, grammarAccess.getTriangularDistributionAccess().getMinKeyword_2());
            		
            otherlv_3=(Token)match(input,20,FOLLOW_21); 

            			newLeafNode(otherlv_3, grammarAccess.getTriangularDistributionAccess().getEqualsSignKeyword_3());
            		
            // InternalSetting.g:1243:3: ( (lv_minExp_4_0= ruleExpression ) )
            // InternalSetting.g:1244:4: (lv_minExp_4_0= ruleExpression )
            {
            // InternalSetting.g:1244:4: (lv_minExp_4_0= ruleExpression )
            // InternalSetting.g:1245:5: lv_minExp_4_0= ruleExpression
            {

            					newCompositeNode(grammarAccess.getTriangularDistributionAccess().getMinExpExpressionParserRuleCall_4_0());
            				
            pushFollow(FOLLOW_27);
            lv_minExp_4_0=ruleExpression();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getTriangularDistributionRule());
            					}
            					set(
            						current,
            						"minExp",
            						lv_minExp_4_0,
            						"org.eclipse.lsat.setting.teditor.Setting.Expression");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            otherlv_5=(Token)match(input,22,FOLLOW_32); 

            			newLeafNode(otherlv_5, grammarAccess.getTriangularDistributionAccess().getCommaKeyword_5());
            		
            otherlv_6=(Token)match(input,25,FOLLOW_20); 

            			newLeafNode(otherlv_6, grammarAccess.getTriangularDistributionAccess().getMaxKeyword_6());
            		
            otherlv_7=(Token)match(input,20,FOLLOW_21); 

            			newLeafNode(otherlv_7, grammarAccess.getTriangularDistributionAccess().getEqualsSignKeyword_7());
            		
            // InternalSetting.g:1274:3: ( (lv_maxExp_8_0= ruleExpression ) )
            // InternalSetting.g:1275:4: (lv_maxExp_8_0= ruleExpression )
            {
            // InternalSetting.g:1275:4: (lv_maxExp_8_0= ruleExpression )
            // InternalSetting.g:1276:5: lv_maxExp_8_0= ruleExpression
            {

            					newCompositeNode(grammarAccess.getTriangularDistributionAccess().getMaxExpExpressionParserRuleCall_8_0());
            				
            pushFollow(FOLLOW_27);
            lv_maxExp_8_0=ruleExpression();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getTriangularDistributionRule());
            					}
            					set(
            						current,
            						"maxExp",
            						lv_maxExp_8_0,
            						"org.eclipse.lsat.setting.teditor.Setting.Expression");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            otherlv_9=(Token)match(input,22,FOLLOW_33); 

            			newLeafNode(otherlv_9, grammarAccess.getTriangularDistributionAccess().getCommaKeyword_9());
            		
            otherlv_10=(Token)match(input,29,FOLLOW_20); 

            			newLeafNode(otherlv_10, grammarAccess.getTriangularDistributionAccess().getModeKeyword_10());
            		
            otherlv_11=(Token)match(input,20,FOLLOW_21); 

            			newLeafNode(otherlv_11, grammarAccess.getTriangularDistributionAccess().getEqualsSignKeyword_11());
            		
            // InternalSetting.g:1305:3: ( (lv_modeExp_12_0= ruleExpression ) )
            // InternalSetting.g:1306:4: (lv_modeExp_12_0= ruleExpression )
            {
            // InternalSetting.g:1306:4: (lv_modeExp_12_0= ruleExpression )
            // InternalSetting.g:1307:5: lv_modeExp_12_0= ruleExpression
            {

            					newCompositeNode(grammarAccess.getTriangularDistributionAccess().getModeExpExpressionParserRuleCall_12_0());
            				
            pushFollow(FOLLOW_25);
            lv_modeExp_12_0=ruleExpression();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getTriangularDistributionRule());
            					}
            					set(
            						current,
            						"modeExp",
            						lv_modeExp_12_0,
            						"org.eclipse.lsat.setting.teditor.Setting.Expression");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalSetting.g:1324:3: (otherlv_13= ',' otherlv_14= 'default' otherlv_15= '=' ( (lv_defaultExp_16_0= ruleExpression ) ) )?
            int alt20=2;
            int LA20_0 = input.LA(1);

            if ( (LA20_0==22) ) {
                alt20=1;
            }
            switch (alt20) {
                case 1 :
                    // InternalSetting.g:1325:4: otherlv_13= ',' otherlv_14= 'default' otherlv_15= '=' ( (lv_defaultExp_16_0= ruleExpression ) )
                    {
                    otherlv_13=(Token)match(input,22,FOLLOW_29); 

                    				newLeafNode(otherlv_13, grammarAccess.getTriangularDistributionAccess().getCommaKeyword_13_0());
                    			
                    otherlv_14=(Token)match(input,26,FOLLOW_20); 

                    				newLeafNode(otherlv_14, grammarAccess.getTriangularDistributionAccess().getDefaultKeyword_13_1());
                    			
                    otherlv_15=(Token)match(input,20,FOLLOW_21); 

                    				newLeafNode(otherlv_15, grammarAccess.getTriangularDistributionAccess().getEqualsSignKeyword_13_2());
                    			
                    // InternalSetting.g:1337:4: ( (lv_defaultExp_16_0= ruleExpression ) )
                    // InternalSetting.g:1338:5: (lv_defaultExp_16_0= ruleExpression )
                    {
                    // InternalSetting.g:1338:5: (lv_defaultExp_16_0= ruleExpression )
                    // InternalSetting.g:1339:6: lv_defaultExp_16_0= ruleExpression
                    {

                    						newCompositeNode(grammarAccess.getTriangularDistributionAccess().getDefaultExpExpressionParserRuleCall_13_3_0());
                    					
                    pushFollow(FOLLOW_30);
                    lv_defaultExp_16_0=ruleExpression();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getTriangularDistributionRule());
                    						}
                    						set(
                    							current,
                    							"defaultExp",
                    							lv_defaultExp_16_0,
                    							"org.eclipse.lsat.setting.teditor.Setting.Expression");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }


                    }
                    break;

            }

            otherlv_17=(Token)match(input,23,FOLLOW_2); 

            			newLeafNode(otherlv_17, grammarAccess.getTriangularDistributionAccess().getRightParenthesisKeyword_14());
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleTriangularDistribution"


    // $ANTLR start "entryRulePertDistribution"
    // InternalSetting.g:1365:1: entryRulePertDistribution returns [EObject current=null] : iv_rulePertDistribution= rulePertDistribution EOF ;
    public final EObject entryRulePertDistribution() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePertDistribution = null;


        try {
            // InternalSetting.g:1365:57: (iv_rulePertDistribution= rulePertDistribution EOF )
            // InternalSetting.g:1366:2: iv_rulePertDistribution= rulePertDistribution EOF
            {
             newCompositeNode(grammarAccess.getPertDistributionRule()); 
            pushFollow(FOLLOW_1);
            iv_rulePertDistribution=rulePertDistribution();

            state._fsp--;

             current =iv_rulePertDistribution; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulePertDistribution"


    // $ANTLR start "rulePertDistribution"
    // InternalSetting.g:1372:1: rulePertDistribution returns [EObject current=null] : (otherlv_0= 'Pert' otherlv_1= '(' otherlv_2= 'min' otherlv_3= '=' ( (lv_minExp_4_0= ruleExpression ) ) otherlv_5= ',' otherlv_6= 'max' otherlv_7= '=' ( (lv_maxExp_8_0= ruleExpression ) ) otherlv_9= ',' otherlv_10= 'mode' otherlv_11= '=' ( (lv_modeExp_12_0= ruleExpression ) ) otherlv_13= ',' otherlv_14= 'gamma' otherlv_15= '=' ( (lv_gammaExp_16_0= ruleExpression ) ) (otherlv_17= ',' otherlv_18= 'default' otherlv_19= '=' ( (lv_defaultExp_20_0= ruleExpression ) ) )? otherlv_21= ')' ) ;
    public final EObject rulePertDistribution() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_1=null;
        Token otherlv_2=null;
        Token otherlv_3=null;
        Token otherlv_5=null;
        Token otherlv_6=null;
        Token otherlv_7=null;
        Token otherlv_9=null;
        Token otherlv_10=null;
        Token otherlv_11=null;
        Token otherlv_13=null;
        Token otherlv_14=null;
        Token otherlv_15=null;
        Token otherlv_17=null;
        Token otherlv_18=null;
        Token otherlv_19=null;
        Token otherlv_21=null;
        EObject lv_minExp_4_0 = null;

        EObject lv_maxExp_8_0 = null;

        EObject lv_modeExp_12_0 = null;

        EObject lv_gammaExp_16_0 = null;

        EObject lv_defaultExp_20_0 = null;



        	enterRule();

        try {
            // InternalSetting.g:1378:2: ( (otherlv_0= 'Pert' otherlv_1= '(' otherlv_2= 'min' otherlv_3= '=' ( (lv_minExp_4_0= ruleExpression ) ) otherlv_5= ',' otherlv_6= 'max' otherlv_7= '=' ( (lv_maxExp_8_0= ruleExpression ) ) otherlv_9= ',' otherlv_10= 'mode' otherlv_11= '=' ( (lv_modeExp_12_0= ruleExpression ) ) otherlv_13= ',' otherlv_14= 'gamma' otherlv_15= '=' ( (lv_gammaExp_16_0= ruleExpression ) ) (otherlv_17= ',' otherlv_18= 'default' otherlv_19= '=' ( (lv_defaultExp_20_0= ruleExpression ) ) )? otherlv_21= ')' ) )
            // InternalSetting.g:1379:2: (otherlv_0= 'Pert' otherlv_1= '(' otherlv_2= 'min' otherlv_3= '=' ( (lv_minExp_4_0= ruleExpression ) ) otherlv_5= ',' otherlv_6= 'max' otherlv_7= '=' ( (lv_maxExp_8_0= ruleExpression ) ) otherlv_9= ',' otherlv_10= 'mode' otherlv_11= '=' ( (lv_modeExp_12_0= ruleExpression ) ) otherlv_13= ',' otherlv_14= 'gamma' otherlv_15= '=' ( (lv_gammaExp_16_0= ruleExpression ) ) (otherlv_17= ',' otherlv_18= 'default' otherlv_19= '=' ( (lv_defaultExp_20_0= ruleExpression ) ) )? otherlv_21= ')' )
            {
            // InternalSetting.g:1379:2: (otherlv_0= 'Pert' otherlv_1= '(' otherlv_2= 'min' otherlv_3= '=' ( (lv_minExp_4_0= ruleExpression ) ) otherlv_5= ',' otherlv_6= 'max' otherlv_7= '=' ( (lv_maxExp_8_0= ruleExpression ) ) otherlv_9= ',' otherlv_10= 'mode' otherlv_11= '=' ( (lv_modeExp_12_0= ruleExpression ) ) otherlv_13= ',' otherlv_14= 'gamma' otherlv_15= '=' ( (lv_gammaExp_16_0= ruleExpression ) ) (otherlv_17= ',' otherlv_18= 'default' otherlv_19= '=' ( (lv_defaultExp_20_0= ruleExpression ) ) )? otherlv_21= ')' )
            // InternalSetting.g:1380:3: otherlv_0= 'Pert' otherlv_1= '(' otherlv_2= 'min' otherlv_3= '=' ( (lv_minExp_4_0= ruleExpression ) ) otherlv_5= ',' otherlv_6= 'max' otherlv_7= '=' ( (lv_maxExp_8_0= ruleExpression ) ) otherlv_9= ',' otherlv_10= 'mode' otherlv_11= '=' ( (lv_modeExp_12_0= ruleExpression ) ) otherlv_13= ',' otherlv_14= 'gamma' otherlv_15= '=' ( (lv_gammaExp_16_0= ruleExpression ) ) (otherlv_17= ',' otherlv_18= 'default' otherlv_19= '=' ( (lv_defaultExp_20_0= ruleExpression ) ) )? otherlv_21= ')'
            {
            otherlv_0=(Token)match(input,30,FOLLOW_23); 

            			newLeafNode(otherlv_0, grammarAccess.getPertDistributionAccess().getPertKeyword_0());
            		
            otherlv_1=(Token)match(input,21,FOLLOW_31); 

            			newLeafNode(otherlv_1, grammarAccess.getPertDistributionAccess().getLeftParenthesisKeyword_1());
            		
            otherlv_2=(Token)match(input,24,FOLLOW_20); 

            			newLeafNode(otherlv_2, grammarAccess.getPertDistributionAccess().getMinKeyword_2());
            		
            otherlv_3=(Token)match(input,20,FOLLOW_21); 

            			newLeafNode(otherlv_3, grammarAccess.getPertDistributionAccess().getEqualsSignKeyword_3());
            		
            // InternalSetting.g:1396:3: ( (lv_minExp_4_0= ruleExpression ) )
            // InternalSetting.g:1397:4: (lv_minExp_4_0= ruleExpression )
            {
            // InternalSetting.g:1397:4: (lv_minExp_4_0= ruleExpression )
            // InternalSetting.g:1398:5: lv_minExp_4_0= ruleExpression
            {

            					newCompositeNode(grammarAccess.getPertDistributionAccess().getMinExpExpressionParserRuleCall_4_0());
            				
            pushFollow(FOLLOW_27);
            lv_minExp_4_0=ruleExpression();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getPertDistributionRule());
            					}
            					set(
            						current,
            						"minExp",
            						lv_minExp_4_0,
            						"org.eclipse.lsat.setting.teditor.Setting.Expression");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            otherlv_5=(Token)match(input,22,FOLLOW_32); 

            			newLeafNode(otherlv_5, grammarAccess.getPertDistributionAccess().getCommaKeyword_5());
            		
            otherlv_6=(Token)match(input,25,FOLLOW_20); 

            			newLeafNode(otherlv_6, grammarAccess.getPertDistributionAccess().getMaxKeyword_6());
            		
            otherlv_7=(Token)match(input,20,FOLLOW_21); 

            			newLeafNode(otherlv_7, grammarAccess.getPertDistributionAccess().getEqualsSignKeyword_7());
            		
            // InternalSetting.g:1427:3: ( (lv_maxExp_8_0= ruleExpression ) )
            // InternalSetting.g:1428:4: (lv_maxExp_8_0= ruleExpression )
            {
            // InternalSetting.g:1428:4: (lv_maxExp_8_0= ruleExpression )
            // InternalSetting.g:1429:5: lv_maxExp_8_0= ruleExpression
            {

            					newCompositeNode(grammarAccess.getPertDistributionAccess().getMaxExpExpressionParserRuleCall_8_0());
            				
            pushFollow(FOLLOW_27);
            lv_maxExp_8_0=ruleExpression();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getPertDistributionRule());
            					}
            					set(
            						current,
            						"maxExp",
            						lv_maxExp_8_0,
            						"org.eclipse.lsat.setting.teditor.Setting.Expression");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            otherlv_9=(Token)match(input,22,FOLLOW_33); 

            			newLeafNode(otherlv_9, grammarAccess.getPertDistributionAccess().getCommaKeyword_9());
            		
            otherlv_10=(Token)match(input,29,FOLLOW_20); 

            			newLeafNode(otherlv_10, grammarAccess.getPertDistributionAccess().getModeKeyword_10());
            		
            otherlv_11=(Token)match(input,20,FOLLOW_21); 

            			newLeafNode(otherlv_11, grammarAccess.getPertDistributionAccess().getEqualsSignKeyword_11());
            		
            // InternalSetting.g:1458:3: ( (lv_modeExp_12_0= ruleExpression ) )
            // InternalSetting.g:1459:4: (lv_modeExp_12_0= ruleExpression )
            {
            // InternalSetting.g:1459:4: (lv_modeExp_12_0= ruleExpression )
            // InternalSetting.g:1460:5: lv_modeExp_12_0= ruleExpression
            {

            					newCompositeNode(grammarAccess.getPertDistributionAccess().getModeExpExpressionParserRuleCall_12_0());
            				
            pushFollow(FOLLOW_27);
            lv_modeExp_12_0=ruleExpression();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getPertDistributionRule());
            					}
            					set(
            						current,
            						"modeExp",
            						lv_modeExp_12_0,
            						"org.eclipse.lsat.setting.teditor.Setting.Expression");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            otherlv_13=(Token)match(input,22,FOLLOW_34); 

            			newLeafNode(otherlv_13, grammarAccess.getPertDistributionAccess().getCommaKeyword_13());
            		
            otherlv_14=(Token)match(input,31,FOLLOW_20); 

            			newLeafNode(otherlv_14, grammarAccess.getPertDistributionAccess().getGammaKeyword_14());
            		
            otherlv_15=(Token)match(input,20,FOLLOW_21); 

            			newLeafNode(otherlv_15, grammarAccess.getPertDistributionAccess().getEqualsSignKeyword_15());
            		
            // InternalSetting.g:1489:3: ( (lv_gammaExp_16_0= ruleExpression ) )
            // InternalSetting.g:1490:4: (lv_gammaExp_16_0= ruleExpression )
            {
            // InternalSetting.g:1490:4: (lv_gammaExp_16_0= ruleExpression )
            // InternalSetting.g:1491:5: lv_gammaExp_16_0= ruleExpression
            {

            					newCompositeNode(grammarAccess.getPertDistributionAccess().getGammaExpExpressionParserRuleCall_16_0());
            				
            pushFollow(FOLLOW_25);
            lv_gammaExp_16_0=ruleExpression();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getPertDistributionRule());
            					}
            					set(
            						current,
            						"gammaExp",
            						lv_gammaExp_16_0,
            						"org.eclipse.lsat.setting.teditor.Setting.Expression");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalSetting.g:1508:3: (otherlv_17= ',' otherlv_18= 'default' otherlv_19= '=' ( (lv_defaultExp_20_0= ruleExpression ) ) )?
            int alt21=2;
            int LA21_0 = input.LA(1);

            if ( (LA21_0==22) ) {
                alt21=1;
            }
            switch (alt21) {
                case 1 :
                    // InternalSetting.g:1509:4: otherlv_17= ',' otherlv_18= 'default' otherlv_19= '=' ( (lv_defaultExp_20_0= ruleExpression ) )
                    {
                    otherlv_17=(Token)match(input,22,FOLLOW_29); 

                    				newLeafNode(otherlv_17, grammarAccess.getPertDistributionAccess().getCommaKeyword_17_0());
                    			
                    otherlv_18=(Token)match(input,26,FOLLOW_20); 

                    				newLeafNode(otherlv_18, grammarAccess.getPertDistributionAccess().getDefaultKeyword_17_1());
                    			
                    otherlv_19=(Token)match(input,20,FOLLOW_21); 

                    				newLeafNode(otherlv_19, grammarAccess.getPertDistributionAccess().getEqualsSignKeyword_17_2());
                    			
                    // InternalSetting.g:1521:4: ( (lv_defaultExp_20_0= ruleExpression ) )
                    // InternalSetting.g:1522:5: (lv_defaultExp_20_0= ruleExpression )
                    {
                    // InternalSetting.g:1522:5: (lv_defaultExp_20_0= ruleExpression )
                    // InternalSetting.g:1523:6: lv_defaultExp_20_0= ruleExpression
                    {

                    						newCompositeNode(grammarAccess.getPertDistributionAccess().getDefaultExpExpressionParserRuleCall_17_3_0());
                    					
                    pushFollow(FOLLOW_30);
                    lv_defaultExp_20_0=ruleExpression();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getPertDistributionRule());
                    						}
                    						set(
                    							current,
                    							"defaultExp",
                    							lv_defaultExp_20_0,
                    							"org.eclipse.lsat.setting.teditor.Setting.Expression");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }


                    }
                    break;

            }

            otherlv_21=(Token)match(input,23,FOLLOW_2); 

            			newLeafNode(otherlv_21, grammarAccess.getPertDistributionAccess().getRightParenthesisKeyword_18());
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "rulePertDistribution"


    // $ANTLR start "entryRuleNormalDistribution"
    // InternalSetting.g:1549:1: entryRuleNormalDistribution returns [EObject current=null] : iv_ruleNormalDistribution= ruleNormalDistribution EOF ;
    public final EObject entryRuleNormalDistribution() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleNormalDistribution = null;


        try {
            // InternalSetting.g:1549:59: (iv_ruleNormalDistribution= ruleNormalDistribution EOF )
            // InternalSetting.g:1550:2: iv_ruleNormalDistribution= ruleNormalDistribution EOF
            {
             newCompositeNode(grammarAccess.getNormalDistributionRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleNormalDistribution=ruleNormalDistribution();

            state._fsp--;

             current =iv_ruleNormalDistribution; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleNormalDistribution"


    // $ANTLR start "ruleNormalDistribution"
    // InternalSetting.g:1556:1: ruleNormalDistribution returns [EObject current=null] : (otherlv_0= 'Normal' otherlv_1= '(' otherlv_2= 'mean' otherlv_3= '=' ( (lv_meanExp_4_0= ruleExpression ) ) otherlv_5= ',' otherlv_6= 'sd' otherlv_7= '=' ( (lv_sdExp_8_0= ruleExpression ) ) (otherlv_9= ',' otherlv_10= 'default' otherlv_11= '=' ( (lv_defaultExp_12_0= ruleExpression ) ) )? otherlv_13= ')' ) ;
    public final EObject ruleNormalDistribution() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_1=null;
        Token otherlv_2=null;
        Token otherlv_3=null;
        Token otherlv_5=null;
        Token otherlv_6=null;
        Token otherlv_7=null;
        Token otherlv_9=null;
        Token otherlv_10=null;
        Token otherlv_11=null;
        Token otherlv_13=null;
        EObject lv_meanExp_4_0 = null;

        EObject lv_sdExp_8_0 = null;

        EObject lv_defaultExp_12_0 = null;



        	enterRule();

        try {
            // InternalSetting.g:1562:2: ( (otherlv_0= 'Normal' otherlv_1= '(' otherlv_2= 'mean' otherlv_3= '=' ( (lv_meanExp_4_0= ruleExpression ) ) otherlv_5= ',' otherlv_6= 'sd' otherlv_7= '=' ( (lv_sdExp_8_0= ruleExpression ) ) (otherlv_9= ',' otherlv_10= 'default' otherlv_11= '=' ( (lv_defaultExp_12_0= ruleExpression ) ) )? otherlv_13= ')' ) )
            // InternalSetting.g:1563:2: (otherlv_0= 'Normal' otherlv_1= '(' otherlv_2= 'mean' otherlv_3= '=' ( (lv_meanExp_4_0= ruleExpression ) ) otherlv_5= ',' otherlv_6= 'sd' otherlv_7= '=' ( (lv_sdExp_8_0= ruleExpression ) ) (otherlv_9= ',' otherlv_10= 'default' otherlv_11= '=' ( (lv_defaultExp_12_0= ruleExpression ) ) )? otherlv_13= ')' )
            {
            // InternalSetting.g:1563:2: (otherlv_0= 'Normal' otherlv_1= '(' otherlv_2= 'mean' otherlv_3= '=' ( (lv_meanExp_4_0= ruleExpression ) ) otherlv_5= ',' otherlv_6= 'sd' otherlv_7= '=' ( (lv_sdExp_8_0= ruleExpression ) ) (otherlv_9= ',' otherlv_10= 'default' otherlv_11= '=' ( (lv_defaultExp_12_0= ruleExpression ) ) )? otherlv_13= ')' )
            // InternalSetting.g:1564:3: otherlv_0= 'Normal' otherlv_1= '(' otherlv_2= 'mean' otherlv_3= '=' ( (lv_meanExp_4_0= ruleExpression ) ) otherlv_5= ',' otherlv_6= 'sd' otherlv_7= '=' ( (lv_sdExp_8_0= ruleExpression ) ) (otherlv_9= ',' otherlv_10= 'default' otherlv_11= '=' ( (lv_defaultExp_12_0= ruleExpression ) ) )? otherlv_13= ')'
            {
            otherlv_0=(Token)match(input,32,FOLLOW_23); 

            			newLeafNode(otherlv_0, grammarAccess.getNormalDistributionAccess().getNormalKeyword_0());
            		
            otherlv_1=(Token)match(input,21,FOLLOW_35); 

            			newLeafNode(otherlv_1, grammarAccess.getNormalDistributionAccess().getLeftParenthesisKeyword_1());
            		
            otherlv_2=(Token)match(input,33,FOLLOW_20); 

            			newLeafNode(otherlv_2, grammarAccess.getNormalDistributionAccess().getMeanKeyword_2());
            		
            otherlv_3=(Token)match(input,20,FOLLOW_21); 

            			newLeafNode(otherlv_3, grammarAccess.getNormalDistributionAccess().getEqualsSignKeyword_3());
            		
            // InternalSetting.g:1580:3: ( (lv_meanExp_4_0= ruleExpression ) )
            // InternalSetting.g:1581:4: (lv_meanExp_4_0= ruleExpression )
            {
            // InternalSetting.g:1581:4: (lv_meanExp_4_0= ruleExpression )
            // InternalSetting.g:1582:5: lv_meanExp_4_0= ruleExpression
            {

            					newCompositeNode(grammarAccess.getNormalDistributionAccess().getMeanExpExpressionParserRuleCall_4_0());
            				
            pushFollow(FOLLOW_27);
            lv_meanExp_4_0=ruleExpression();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getNormalDistributionRule());
            					}
            					set(
            						current,
            						"meanExp",
            						lv_meanExp_4_0,
            						"org.eclipse.lsat.setting.teditor.Setting.Expression");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            otherlv_5=(Token)match(input,22,FOLLOW_36); 

            			newLeafNode(otherlv_5, grammarAccess.getNormalDistributionAccess().getCommaKeyword_5());
            		
            otherlv_6=(Token)match(input,34,FOLLOW_20); 

            			newLeafNode(otherlv_6, grammarAccess.getNormalDistributionAccess().getSdKeyword_6());
            		
            otherlv_7=(Token)match(input,20,FOLLOW_21); 

            			newLeafNode(otherlv_7, grammarAccess.getNormalDistributionAccess().getEqualsSignKeyword_7());
            		
            // InternalSetting.g:1611:3: ( (lv_sdExp_8_0= ruleExpression ) )
            // InternalSetting.g:1612:4: (lv_sdExp_8_0= ruleExpression )
            {
            // InternalSetting.g:1612:4: (lv_sdExp_8_0= ruleExpression )
            // InternalSetting.g:1613:5: lv_sdExp_8_0= ruleExpression
            {

            					newCompositeNode(grammarAccess.getNormalDistributionAccess().getSdExpExpressionParserRuleCall_8_0());
            				
            pushFollow(FOLLOW_25);
            lv_sdExp_8_0=ruleExpression();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getNormalDistributionRule());
            					}
            					set(
            						current,
            						"sdExp",
            						lv_sdExp_8_0,
            						"org.eclipse.lsat.setting.teditor.Setting.Expression");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalSetting.g:1630:3: (otherlv_9= ',' otherlv_10= 'default' otherlv_11= '=' ( (lv_defaultExp_12_0= ruleExpression ) ) )?
            int alt22=2;
            int LA22_0 = input.LA(1);

            if ( (LA22_0==22) ) {
                alt22=1;
            }
            switch (alt22) {
                case 1 :
                    // InternalSetting.g:1631:4: otherlv_9= ',' otherlv_10= 'default' otherlv_11= '=' ( (lv_defaultExp_12_0= ruleExpression ) )
                    {
                    otherlv_9=(Token)match(input,22,FOLLOW_29); 

                    				newLeafNode(otherlv_9, grammarAccess.getNormalDistributionAccess().getCommaKeyword_9_0());
                    			
                    otherlv_10=(Token)match(input,26,FOLLOW_20); 

                    				newLeafNode(otherlv_10, grammarAccess.getNormalDistributionAccess().getDefaultKeyword_9_1());
                    			
                    otherlv_11=(Token)match(input,20,FOLLOW_21); 

                    				newLeafNode(otherlv_11, grammarAccess.getNormalDistributionAccess().getEqualsSignKeyword_9_2());
                    			
                    // InternalSetting.g:1643:4: ( (lv_defaultExp_12_0= ruleExpression ) )
                    // InternalSetting.g:1644:5: (lv_defaultExp_12_0= ruleExpression )
                    {
                    // InternalSetting.g:1644:5: (lv_defaultExp_12_0= ruleExpression )
                    // InternalSetting.g:1645:6: lv_defaultExp_12_0= ruleExpression
                    {

                    						newCompositeNode(grammarAccess.getNormalDistributionAccess().getDefaultExpExpressionParserRuleCall_9_3_0());
                    					
                    pushFollow(FOLLOW_30);
                    lv_defaultExp_12_0=ruleExpression();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getNormalDistributionRule());
                    						}
                    						set(
                    							current,
                    							"defaultExp",
                    							lv_defaultExp_12_0,
                    							"org.eclipse.lsat.setting.teditor.Setting.Expression");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }


                    }
                    break;

            }

            otherlv_13=(Token)match(input,23,FOLLOW_2); 

            			newLeafNode(otherlv_13, grammarAccess.getNormalDistributionAccess().getRightParenthesisKeyword_10());
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleNormalDistribution"


    // $ANTLR start "entryRuleEnumeratedDistribution"
    // InternalSetting.g:1671:1: entryRuleEnumeratedDistribution returns [EObject current=null] : iv_ruleEnumeratedDistribution= ruleEnumeratedDistribution EOF ;
    public final EObject entryRuleEnumeratedDistribution() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleEnumeratedDistribution = null;


        try {
            // InternalSetting.g:1671:63: (iv_ruleEnumeratedDistribution= ruleEnumeratedDistribution EOF )
            // InternalSetting.g:1672:2: iv_ruleEnumeratedDistribution= ruleEnumeratedDistribution EOF
            {
             newCompositeNode(grammarAccess.getEnumeratedDistributionRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleEnumeratedDistribution=ruleEnumeratedDistribution();

            state._fsp--;

             current =iv_ruleEnumeratedDistribution; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleEnumeratedDistribution"


    // $ANTLR start "ruleEnumeratedDistribution"
    // InternalSetting.g:1678:1: ruleEnumeratedDistribution returns [EObject current=null] : (otherlv_0= 'Enumerated' otherlv_1= '(' ( (lv_valuesExp_2_0= ruleExpression ) ) (otherlv_3= ',' ( (lv_valuesExp_4_0= ruleExpression ) ) )* (otherlv_5= ',' otherlv_6= 'default' otherlv_7= '=' ( (lv_defaultExp_8_0= ruleExpression ) ) )? otherlv_9= ')' ) ;
    public final EObject ruleEnumeratedDistribution() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_1=null;
        Token otherlv_3=null;
        Token otherlv_5=null;
        Token otherlv_6=null;
        Token otherlv_7=null;
        Token otherlv_9=null;
        EObject lv_valuesExp_2_0 = null;

        EObject lv_valuesExp_4_0 = null;

        EObject lv_defaultExp_8_0 = null;



        	enterRule();

        try {
            // InternalSetting.g:1684:2: ( (otherlv_0= 'Enumerated' otherlv_1= '(' ( (lv_valuesExp_2_0= ruleExpression ) ) (otherlv_3= ',' ( (lv_valuesExp_4_0= ruleExpression ) ) )* (otherlv_5= ',' otherlv_6= 'default' otherlv_7= '=' ( (lv_defaultExp_8_0= ruleExpression ) ) )? otherlv_9= ')' ) )
            // InternalSetting.g:1685:2: (otherlv_0= 'Enumerated' otherlv_1= '(' ( (lv_valuesExp_2_0= ruleExpression ) ) (otherlv_3= ',' ( (lv_valuesExp_4_0= ruleExpression ) ) )* (otherlv_5= ',' otherlv_6= 'default' otherlv_7= '=' ( (lv_defaultExp_8_0= ruleExpression ) ) )? otherlv_9= ')' )
            {
            // InternalSetting.g:1685:2: (otherlv_0= 'Enumerated' otherlv_1= '(' ( (lv_valuesExp_2_0= ruleExpression ) ) (otherlv_3= ',' ( (lv_valuesExp_4_0= ruleExpression ) ) )* (otherlv_5= ',' otherlv_6= 'default' otherlv_7= '=' ( (lv_defaultExp_8_0= ruleExpression ) ) )? otherlv_9= ')' )
            // InternalSetting.g:1686:3: otherlv_0= 'Enumerated' otherlv_1= '(' ( (lv_valuesExp_2_0= ruleExpression ) ) (otherlv_3= ',' ( (lv_valuesExp_4_0= ruleExpression ) ) )* (otherlv_5= ',' otherlv_6= 'default' otherlv_7= '=' ( (lv_defaultExp_8_0= ruleExpression ) ) )? otherlv_9= ')'
            {
            otherlv_0=(Token)match(input,35,FOLLOW_23); 

            			newLeafNode(otherlv_0, grammarAccess.getEnumeratedDistributionAccess().getEnumeratedKeyword_0());
            		
            otherlv_1=(Token)match(input,21,FOLLOW_21); 

            			newLeafNode(otherlv_1, grammarAccess.getEnumeratedDistributionAccess().getLeftParenthesisKeyword_1());
            		
            // InternalSetting.g:1694:3: ( (lv_valuesExp_2_0= ruleExpression ) )
            // InternalSetting.g:1695:4: (lv_valuesExp_2_0= ruleExpression )
            {
            // InternalSetting.g:1695:4: (lv_valuesExp_2_0= ruleExpression )
            // InternalSetting.g:1696:5: lv_valuesExp_2_0= ruleExpression
            {

            					newCompositeNode(grammarAccess.getEnumeratedDistributionAccess().getValuesExpExpressionParserRuleCall_2_0());
            				
            pushFollow(FOLLOW_25);
            lv_valuesExp_2_0=ruleExpression();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getEnumeratedDistributionRule());
            					}
            					add(
            						current,
            						"valuesExp",
            						lv_valuesExp_2_0,
            						"org.eclipse.lsat.setting.teditor.Setting.Expression");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalSetting.g:1713:3: (otherlv_3= ',' ( (lv_valuesExp_4_0= ruleExpression ) ) )*
            loop23:
            do {
                int alt23=2;
                int LA23_0 = input.LA(1);

                if ( (LA23_0==22) ) {
                    int LA23_1 = input.LA(2);

                    if ( ((LA23_1>=RULE_ID && LA23_1<=RULE_INT)||LA23_1==21||LA23_1==38) ) {
                        alt23=1;
                    }


                }


                switch (alt23) {
            	case 1 :
            	    // InternalSetting.g:1714:4: otherlv_3= ',' ( (lv_valuesExp_4_0= ruleExpression ) )
            	    {
            	    otherlv_3=(Token)match(input,22,FOLLOW_21); 

            	    				newLeafNode(otherlv_3, grammarAccess.getEnumeratedDistributionAccess().getCommaKeyword_3_0());
            	    			
            	    // InternalSetting.g:1718:4: ( (lv_valuesExp_4_0= ruleExpression ) )
            	    // InternalSetting.g:1719:5: (lv_valuesExp_4_0= ruleExpression )
            	    {
            	    // InternalSetting.g:1719:5: (lv_valuesExp_4_0= ruleExpression )
            	    // InternalSetting.g:1720:6: lv_valuesExp_4_0= ruleExpression
            	    {

            	    						newCompositeNode(grammarAccess.getEnumeratedDistributionAccess().getValuesExpExpressionParserRuleCall_3_1_0());
            	    					
            	    pushFollow(FOLLOW_25);
            	    lv_valuesExp_4_0=ruleExpression();

            	    state._fsp--;


            	    						if (current==null) {
            	    							current = createModelElementForParent(grammarAccess.getEnumeratedDistributionRule());
            	    						}
            	    						add(
            	    							current,
            	    							"valuesExp",
            	    							lv_valuesExp_4_0,
            	    							"org.eclipse.lsat.setting.teditor.Setting.Expression");
            	    						afterParserOrEnumRuleCall();
            	    					

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop23;
                }
            } while (true);

            // InternalSetting.g:1738:3: (otherlv_5= ',' otherlv_6= 'default' otherlv_7= '=' ( (lv_defaultExp_8_0= ruleExpression ) ) )?
            int alt24=2;
            int LA24_0 = input.LA(1);

            if ( (LA24_0==22) ) {
                alt24=1;
            }
            switch (alt24) {
                case 1 :
                    // InternalSetting.g:1739:4: otherlv_5= ',' otherlv_6= 'default' otherlv_7= '=' ( (lv_defaultExp_8_0= ruleExpression ) )
                    {
                    otherlv_5=(Token)match(input,22,FOLLOW_29); 

                    				newLeafNode(otherlv_5, grammarAccess.getEnumeratedDistributionAccess().getCommaKeyword_4_0());
                    			
                    otherlv_6=(Token)match(input,26,FOLLOW_20); 

                    				newLeafNode(otherlv_6, grammarAccess.getEnumeratedDistributionAccess().getDefaultKeyword_4_1());
                    			
                    otherlv_7=(Token)match(input,20,FOLLOW_21); 

                    				newLeafNode(otherlv_7, grammarAccess.getEnumeratedDistributionAccess().getEqualsSignKeyword_4_2());
                    			
                    // InternalSetting.g:1751:4: ( (lv_defaultExp_8_0= ruleExpression ) )
                    // InternalSetting.g:1752:5: (lv_defaultExp_8_0= ruleExpression )
                    {
                    // InternalSetting.g:1752:5: (lv_defaultExp_8_0= ruleExpression )
                    // InternalSetting.g:1753:6: lv_defaultExp_8_0= ruleExpression
                    {

                    						newCompositeNode(grammarAccess.getEnumeratedDistributionAccess().getDefaultExpExpressionParserRuleCall_4_3_0());
                    					
                    pushFollow(FOLLOW_30);
                    lv_defaultExp_8_0=ruleExpression();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getEnumeratedDistributionRule());
                    						}
                    						set(
                    							current,
                    							"defaultExp",
                    							lv_defaultExp_8_0,
                    							"org.eclipse.lsat.setting.teditor.Setting.Expression");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }


                    }
                    break;

            }

            otherlv_9=(Token)match(input,23,FOLLOW_2); 

            			newLeafNode(otherlv_9, grammarAccess.getEnumeratedDistributionAccess().getRightParenthesisKeyword_5());
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleEnumeratedDistribution"


    // $ANTLR start "entryRuleDeclaration"
    // InternalSetting.g:1779:1: entryRuleDeclaration returns [EObject current=null] : iv_ruleDeclaration= ruleDeclaration EOF ;
    public final EObject entryRuleDeclaration() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleDeclaration = null;


        try {
            // InternalSetting.g:1779:52: (iv_ruleDeclaration= ruleDeclaration EOF )
            // InternalSetting.g:1780:2: iv_ruleDeclaration= ruleDeclaration EOF
            {
             newCompositeNode(grammarAccess.getDeclarationRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleDeclaration=ruleDeclaration();

            state._fsp--;

             current =iv_ruleDeclaration; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleDeclaration"


    // $ANTLR start "ruleDeclaration"
    // InternalSetting.g:1786:1: ruleDeclaration returns [EObject current=null] : ( () otherlv_1= 'val' ( (lv_name_2_0= RULE_ID ) ) otherlv_3= '=' ( (lv_expression_4_0= ruleExpression ) ) ) ;
    public final EObject ruleDeclaration() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token lv_name_2_0=null;
        Token otherlv_3=null;
        EObject lv_expression_4_0 = null;



        	enterRule();

        try {
            // InternalSetting.g:1792:2: ( ( () otherlv_1= 'val' ( (lv_name_2_0= RULE_ID ) ) otherlv_3= '=' ( (lv_expression_4_0= ruleExpression ) ) ) )
            // InternalSetting.g:1793:2: ( () otherlv_1= 'val' ( (lv_name_2_0= RULE_ID ) ) otherlv_3= '=' ( (lv_expression_4_0= ruleExpression ) ) )
            {
            // InternalSetting.g:1793:2: ( () otherlv_1= 'val' ( (lv_name_2_0= RULE_ID ) ) otherlv_3= '=' ( (lv_expression_4_0= ruleExpression ) ) )
            // InternalSetting.g:1794:3: () otherlv_1= 'val' ( (lv_name_2_0= RULE_ID ) ) otherlv_3= '=' ( (lv_expression_4_0= ruleExpression ) )
            {
            // InternalSetting.g:1794:3: ()
            // InternalSetting.g:1795:4: 
            {

            				current = forceCreateModelElement(
            					grammarAccess.getDeclarationAccess().getDeclarationAction_0(),
            					current);
            			

            }

            otherlv_1=(Token)match(input,36,FOLLOW_13); 

            			newLeafNode(otherlv_1, grammarAccess.getDeclarationAccess().getValKeyword_1());
            		
            // InternalSetting.g:1805:3: ( (lv_name_2_0= RULE_ID ) )
            // InternalSetting.g:1806:4: (lv_name_2_0= RULE_ID )
            {
            // InternalSetting.g:1806:4: (lv_name_2_0= RULE_ID )
            // InternalSetting.g:1807:5: lv_name_2_0= RULE_ID
            {
            lv_name_2_0=(Token)match(input,RULE_ID,FOLLOW_20); 

            					newLeafNode(lv_name_2_0, grammarAccess.getDeclarationAccess().getNameIDTerminalRuleCall_2_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getDeclarationRule());
            					}
            					setWithLastConsumed(
            						current,
            						"name",
            						lv_name_2_0,
            						"org.eclipse.xtext.common.Terminals.ID");
            				

            }


            }

            otherlv_3=(Token)match(input,20,FOLLOW_21); 

            			newLeafNode(otherlv_3, grammarAccess.getDeclarationAccess().getEqualsSignKeyword_3());
            		
            // InternalSetting.g:1827:3: ( (lv_expression_4_0= ruleExpression ) )
            // InternalSetting.g:1828:4: (lv_expression_4_0= ruleExpression )
            {
            // InternalSetting.g:1828:4: (lv_expression_4_0= ruleExpression )
            // InternalSetting.g:1829:5: lv_expression_4_0= ruleExpression
            {

            					newCompositeNode(grammarAccess.getDeclarationAccess().getExpressionExpressionParserRuleCall_4_0());
            				
            pushFollow(FOLLOW_2);
            lv_expression_4_0=ruleExpression();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getDeclarationRule());
            					}
            					set(
            						current,
            						"expression",
            						lv_expression_4_0,
            						"org.eclipse.lsat.setting.teditor.Setting.Expression");
            					afterParserOrEnumRuleCall();
            				

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleDeclaration"


    // $ANTLR start "entryRuleExpression"
    // InternalSetting.g:1850:1: entryRuleExpression returns [EObject current=null] : iv_ruleExpression= ruleExpression EOF ;
    public final EObject entryRuleExpression() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleExpression = null;


        try {
            // InternalSetting.g:1850:51: (iv_ruleExpression= ruleExpression EOF )
            // InternalSetting.g:1851:2: iv_ruleExpression= ruleExpression EOF
            {
             newCompositeNode(grammarAccess.getExpressionRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleExpression=ruleExpression();

            state._fsp--;

             current =iv_ruleExpression; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleExpression"


    // $ANTLR start "ruleExpression"
    // InternalSetting.g:1857:1: ruleExpression returns [EObject current=null] : this_PlusOrMinus_0= rulePlusOrMinus ;
    public final EObject ruleExpression() throws RecognitionException {
        EObject current = null;

        EObject this_PlusOrMinus_0 = null;



        	enterRule();

        try {
            // InternalSetting.g:1863:2: (this_PlusOrMinus_0= rulePlusOrMinus )
            // InternalSetting.g:1864:2: this_PlusOrMinus_0= rulePlusOrMinus
            {

            		newCompositeNode(grammarAccess.getExpressionAccess().getPlusOrMinusParserRuleCall());
            	
            pushFollow(FOLLOW_2);
            this_PlusOrMinus_0=rulePlusOrMinus();

            state._fsp--;


            		current = this_PlusOrMinus_0;
            		afterParserOrEnumRuleCall();
            	

            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleExpression"


    // $ANTLR start "entryRulePlusOrMinus"
    // InternalSetting.g:1875:1: entryRulePlusOrMinus returns [EObject current=null] : iv_rulePlusOrMinus= rulePlusOrMinus EOF ;
    public final EObject entryRulePlusOrMinus() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePlusOrMinus = null;


        try {
            // InternalSetting.g:1875:52: (iv_rulePlusOrMinus= rulePlusOrMinus EOF )
            // InternalSetting.g:1876:2: iv_rulePlusOrMinus= rulePlusOrMinus EOF
            {
             newCompositeNode(grammarAccess.getPlusOrMinusRule()); 
            pushFollow(FOLLOW_1);
            iv_rulePlusOrMinus=rulePlusOrMinus();

            state._fsp--;

             current =iv_rulePlusOrMinus; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulePlusOrMinus"


    // $ANTLR start "rulePlusOrMinus"
    // InternalSetting.g:1882:1: rulePlusOrMinus returns [EObject current=null] : (this_MulOrDiv_0= ruleMulOrDiv ( ( ( () otherlv_2= '+' ) | ( () otherlv_4= '-' ) ) ( (lv_right_5_0= ruleMulOrDiv ) ) )* ) ;
    public final EObject rulePlusOrMinus() throws RecognitionException {
        EObject current = null;

        Token otherlv_2=null;
        Token otherlv_4=null;
        EObject this_MulOrDiv_0 = null;

        EObject lv_right_5_0 = null;



        	enterRule();

        try {
            // InternalSetting.g:1888:2: ( (this_MulOrDiv_0= ruleMulOrDiv ( ( ( () otherlv_2= '+' ) | ( () otherlv_4= '-' ) ) ( (lv_right_5_0= ruleMulOrDiv ) ) )* ) )
            // InternalSetting.g:1889:2: (this_MulOrDiv_0= ruleMulOrDiv ( ( ( () otherlv_2= '+' ) | ( () otherlv_4= '-' ) ) ( (lv_right_5_0= ruleMulOrDiv ) ) )* )
            {
            // InternalSetting.g:1889:2: (this_MulOrDiv_0= ruleMulOrDiv ( ( ( () otherlv_2= '+' ) | ( () otherlv_4= '-' ) ) ( (lv_right_5_0= ruleMulOrDiv ) ) )* )
            // InternalSetting.g:1890:3: this_MulOrDiv_0= ruleMulOrDiv ( ( ( () otherlv_2= '+' ) | ( () otherlv_4= '-' ) ) ( (lv_right_5_0= ruleMulOrDiv ) ) )*
            {

            			newCompositeNode(grammarAccess.getPlusOrMinusAccess().getMulOrDivParserRuleCall_0());
            		
            pushFollow(FOLLOW_37);
            this_MulOrDiv_0=ruleMulOrDiv();

            state._fsp--;


            			current = this_MulOrDiv_0;
            			afterParserOrEnumRuleCall();
            		
            // InternalSetting.g:1898:3: ( ( ( () otherlv_2= '+' ) | ( () otherlv_4= '-' ) ) ( (lv_right_5_0= ruleMulOrDiv ) ) )*
            loop26:
            do {
                int alt26=2;
                int LA26_0 = input.LA(1);

                if ( ((LA26_0>=37 && LA26_0<=38)) ) {
                    alt26=1;
                }


                switch (alt26) {
            	case 1 :
            	    // InternalSetting.g:1899:4: ( ( () otherlv_2= '+' ) | ( () otherlv_4= '-' ) ) ( (lv_right_5_0= ruleMulOrDiv ) )
            	    {
            	    // InternalSetting.g:1899:4: ( ( () otherlv_2= '+' ) | ( () otherlv_4= '-' ) )
            	    int alt25=2;
            	    int LA25_0 = input.LA(1);

            	    if ( (LA25_0==37) ) {
            	        alt25=1;
            	    }
            	    else if ( (LA25_0==38) ) {
            	        alt25=2;
            	    }
            	    else {
            	        NoViableAltException nvae =
            	            new NoViableAltException("", 25, 0, input);

            	        throw nvae;
            	    }
            	    switch (alt25) {
            	        case 1 :
            	            // InternalSetting.g:1900:5: ( () otherlv_2= '+' )
            	            {
            	            // InternalSetting.g:1900:5: ( () otherlv_2= '+' )
            	            // InternalSetting.g:1901:6: () otherlv_2= '+'
            	            {
            	            // InternalSetting.g:1901:6: ()
            	            // InternalSetting.g:1902:7: 
            	            {

            	            							current = forceCreateModelElementAndSet(
            	            								grammarAccess.getPlusOrMinusAccess().getAddLeftAction_1_0_0_0(),
            	            								current);
            	            						

            	            }

            	            otherlv_2=(Token)match(input,37,FOLLOW_21); 

            	            						newLeafNode(otherlv_2, grammarAccess.getPlusOrMinusAccess().getPlusSignKeyword_1_0_0_1());
            	            					

            	            }


            	            }
            	            break;
            	        case 2 :
            	            // InternalSetting.g:1914:5: ( () otherlv_4= '-' )
            	            {
            	            // InternalSetting.g:1914:5: ( () otherlv_4= '-' )
            	            // InternalSetting.g:1915:6: () otherlv_4= '-'
            	            {
            	            // InternalSetting.g:1915:6: ()
            	            // InternalSetting.g:1916:7: 
            	            {

            	            							current = forceCreateModelElementAndSet(
            	            								grammarAccess.getPlusOrMinusAccess().getSubtractLeftAction_1_0_1_0(),
            	            								current);
            	            						

            	            }

            	            otherlv_4=(Token)match(input,38,FOLLOW_21); 

            	            						newLeafNode(otherlv_4, grammarAccess.getPlusOrMinusAccess().getHyphenMinusKeyword_1_0_1_1());
            	            					

            	            }


            	            }
            	            break;

            	    }

            	    // InternalSetting.g:1928:4: ( (lv_right_5_0= ruleMulOrDiv ) )
            	    // InternalSetting.g:1929:5: (lv_right_5_0= ruleMulOrDiv )
            	    {
            	    // InternalSetting.g:1929:5: (lv_right_5_0= ruleMulOrDiv )
            	    // InternalSetting.g:1930:6: lv_right_5_0= ruleMulOrDiv
            	    {

            	    						newCompositeNode(grammarAccess.getPlusOrMinusAccess().getRightMulOrDivParserRuleCall_1_1_0());
            	    					
            	    pushFollow(FOLLOW_37);
            	    lv_right_5_0=ruleMulOrDiv();

            	    state._fsp--;


            	    						if (current==null) {
            	    							current = createModelElementForParent(grammarAccess.getPlusOrMinusRule());
            	    						}
            	    						set(
            	    							current,
            	    							"right",
            	    							lv_right_5_0,
            	    							"org.eclipse.lsat.setting.teditor.Setting.MulOrDiv");
            	    						afterParserOrEnumRuleCall();
            	    					

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop26;
                }
            } while (true);


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "rulePlusOrMinus"


    // $ANTLR start "entryRuleMulOrDiv"
    // InternalSetting.g:1952:1: entryRuleMulOrDiv returns [EObject current=null] : iv_ruleMulOrDiv= ruleMulOrDiv EOF ;
    public final EObject entryRuleMulOrDiv() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleMulOrDiv = null;


        try {
            // InternalSetting.g:1952:49: (iv_ruleMulOrDiv= ruleMulOrDiv EOF )
            // InternalSetting.g:1953:2: iv_ruleMulOrDiv= ruleMulOrDiv EOF
            {
             newCompositeNode(grammarAccess.getMulOrDivRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleMulOrDiv=ruleMulOrDiv();

            state._fsp--;

             current =iv_ruleMulOrDiv; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleMulOrDiv"


    // $ANTLR start "ruleMulOrDiv"
    // InternalSetting.g:1959:1: ruleMulOrDiv returns [EObject current=null] : (this_Primary_0= rulePrimary ( ( ( () otherlv_2= '*' ) | ( () otherlv_4= '/' ) ) ( (lv_right_5_0= rulePrimary ) ) )* ) ;
    public final EObject ruleMulOrDiv() throws RecognitionException {
        EObject current = null;

        Token otherlv_2=null;
        Token otherlv_4=null;
        EObject this_Primary_0 = null;

        EObject lv_right_5_0 = null;



        	enterRule();

        try {
            // InternalSetting.g:1965:2: ( (this_Primary_0= rulePrimary ( ( ( () otherlv_2= '*' ) | ( () otherlv_4= '/' ) ) ( (lv_right_5_0= rulePrimary ) ) )* ) )
            // InternalSetting.g:1966:2: (this_Primary_0= rulePrimary ( ( ( () otherlv_2= '*' ) | ( () otherlv_4= '/' ) ) ( (lv_right_5_0= rulePrimary ) ) )* )
            {
            // InternalSetting.g:1966:2: (this_Primary_0= rulePrimary ( ( ( () otherlv_2= '*' ) | ( () otherlv_4= '/' ) ) ( (lv_right_5_0= rulePrimary ) ) )* )
            // InternalSetting.g:1967:3: this_Primary_0= rulePrimary ( ( ( () otherlv_2= '*' ) | ( () otherlv_4= '/' ) ) ( (lv_right_5_0= rulePrimary ) ) )*
            {

            			newCompositeNode(grammarAccess.getMulOrDivAccess().getPrimaryParserRuleCall_0());
            		
            pushFollow(FOLLOW_38);
            this_Primary_0=rulePrimary();

            state._fsp--;


            			current = this_Primary_0;
            			afterParserOrEnumRuleCall();
            		
            // InternalSetting.g:1975:3: ( ( ( () otherlv_2= '*' ) | ( () otherlv_4= '/' ) ) ( (lv_right_5_0= rulePrimary ) ) )*
            loop28:
            do {
                int alt28=2;
                int LA28_0 = input.LA(1);

                if ( ((LA28_0>=39 && LA28_0<=40)) ) {
                    alt28=1;
                }


                switch (alt28) {
            	case 1 :
            	    // InternalSetting.g:1976:4: ( ( () otherlv_2= '*' ) | ( () otherlv_4= '/' ) ) ( (lv_right_5_0= rulePrimary ) )
            	    {
            	    // InternalSetting.g:1976:4: ( ( () otherlv_2= '*' ) | ( () otherlv_4= '/' ) )
            	    int alt27=2;
            	    int LA27_0 = input.LA(1);

            	    if ( (LA27_0==39) ) {
            	        alt27=1;
            	    }
            	    else if ( (LA27_0==40) ) {
            	        alt27=2;
            	    }
            	    else {
            	        NoViableAltException nvae =
            	            new NoViableAltException("", 27, 0, input);

            	        throw nvae;
            	    }
            	    switch (alt27) {
            	        case 1 :
            	            // InternalSetting.g:1977:5: ( () otherlv_2= '*' )
            	            {
            	            // InternalSetting.g:1977:5: ( () otherlv_2= '*' )
            	            // InternalSetting.g:1978:6: () otherlv_2= '*'
            	            {
            	            // InternalSetting.g:1978:6: ()
            	            // InternalSetting.g:1979:7: 
            	            {

            	            							current = forceCreateModelElementAndSet(
            	            								grammarAccess.getMulOrDivAccess().getMultiplyLeftAction_1_0_0_0(),
            	            								current);
            	            						

            	            }

            	            otherlv_2=(Token)match(input,39,FOLLOW_21); 

            	            						newLeafNode(otherlv_2, grammarAccess.getMulOrDivAccess().getAsteriskKeyword_1_0_0_1());
            	            					

            	            }


            	            }
            	            break;
            	        case 2 :
            	            // InternalSetting.g:1991:5: ( () otherlv_4= '/' )
            	            {
            	            // InternalSetting.g:1991:5: ( () otherlv_4= '/' )
            	            // InternalSetting.g:1992:6: () otherlv_4= '/'
            	            {
            	            // InternalSetting.g:1992:6: ()
            	            // InternalSetting.g:1993:7: 
            	            {

            	            							current = forceCreateModelElementAndSet(
            	            								grammarAccess.getMulOrDivAccess().getDivideLeftAction_1_0_1_0(),
            	            								current);
            	            						

            	            }

            	            otherlv_4=(Token)match(input,40,FOLLOW_21); 

            	            						newLeafNode(otherlv_4, grammarAccess.getMulOrDivAccess().getSolidusKeyword_1_0_1_1());
            	            					

            	            }


            	            }
            	            break;

            	    }

            	    // InternalSetting.g:2005:4: ( (lv_right_5_0= rulePrimary ) )
            	    // InternalSetting.g:2006:5: (lv_right_5_0= rulePrimary )
            	    {
            	    // InternalSetting.g:2006:5: (lv_right_5_0= rulePrimary )
            	    // InternalSetting.g:2007:6: lv_right_5_0= rulePrimary
            	    {

            	    						newCompositeNode(grammarAccess.getMulOrDivAccess().getRightPrimaryParserRuleCall_1_1_0());
            	    					
            	    pushFollow(FOLLOW_38);
            	    lv_right_5_0=rulePrimary();

            	    state._fsp--;


            	    						if (current==null) {
            	    							current = createModelElementForParent(grammarAccess.getMulOrDivRule());
            	    						}
            	    						set(
            	    							current,
            	    							"right",
            	    							lv_right_5_0,
            	    							"org.eclipse.lsat.setting.teditor.Setting.Primary");
            	    						afterParserOrEnumRuleCall();
            	    					

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop28;
                }
            } while (true);


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleMulOrDiv"


    // $ANTLR start "entryRulePrimary"
    // InternalSetting.g:2029:1: entryRulePrimary returns [EObject current=null] : iv_rulePrimary= rulePrimary EOF ;
    public final EObject entryRulePrimary() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePrimary = null;


        try {
            // InternalSetting.g:2029:48: (iv_rulePrimary= rulePrimary EOF )
            // InternalSetting.g:2030:2: iv_rulePrimary= rulePrimary EOF
            {
             newCompositeNode(grammarAccess.getPrimaryRule()); 
            pushFollow(FOLLOW_1);
            iv_rulePrimary=rulePrimary();

            state._fsp--;

             current =iv_rulePrimary; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulePrimary"


    // $ANTLR start "rulePrimary"
    // InternalSetting.g:2036:1: rulePrimary returns [EObject current=null] : ( (otherlv_0= '(' this_Expression_1= ruleExpression otherlv_2= ')' ) | this_Atomic_3= ruleAtomic ) ;
    public final EObject rulePrimary() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_2=null;
        EObject this_Expression_1 = null;

        EObject this_Atomic_3 = null;



        	enterRule();

        try {
            // InternalSetting.g:2042:2: ( ( (otherlv_0= '(' this_Expression_1= ruleExpression otherlv_2= ')' ) | this_Atomic_3= ruleAtomic ) )
            // InternalSetting.g:2043:2: ( (otherlv_0= '(' this_Expression_1= ruleExpression otherlv_2= ')' ) | this_Atomic_3= ruleAtomic )
            {
            // InternalSetting.g:2043:2: ( (otherlv_0= '(' this_Expression_1= ruleExpression otherlv_2= ')' ) | this_Atomic_3= ruleAtomic )
            int alt29=2;
            int LA29_0 = input.LA(1);

            if ( (LA29_0==21) ) {
                alt29=1;
            }
            else if ( ((LA29_0>=RULE_ID && LA29_0<=RULE_INT)||LA29_0==38) ) {
                alt29=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 29, 0, input);

                throw nvae;
            }
            switch (alt29) {
                case 1 :
                    // InternalSetting.g:2044:3: (otherlv_0= '(' this_Expression_1= ruleExpression otherlv_2= ')' )
                    {
                    // InternalSetting.g:2044:3: (otherlv_0= '(' this_Expression_1= ruleExpression otherlv_2= ')' )
                    // InternalSetting.g:2045:4: otherlv_0= '(' this_Expression_1= ruleExpression otherlv_2= ')'
                    {
                    otherlv_0=(Token)match(input,21,FOLLOW_21); 

                    				newLeafNode(otherlv_0, grammarAccess.getPrimaryAccess().getLeftParenthesisKeyword_0_0());
                    			

                    				newCompositeNode(grammarAccess.getPrimaryAccess().getExpressionParserRuleCall_0_1());
                    			
                    pushFollow(FOLLOW_30);
                    this_Expression_1=ruleExpression();

                    state._fsp--;


                    				current = this_Expression_1;
                    				afterParserOrEnumRuleCall();
                    			
                    otherlv_2=(Token)match(input,23,FOLLOW_2); 

                    				newLeafNode(otherlv_2, grammarAccess.getPrimaryAccess().getRightParenthesisKeyword_0_2());
                    			

                    }


                    }
                    break;
                case 2 :
                    // InternalSetting.g:2063:3: this_Atomic_3= ruleAtomic
                    {

                    			newCompositeNode(grammarAccess.getPrimaryAccess().getAtomicParserRuleCall_1());
                    		
                    pushFollow(FOLLOW_2);
                    this_Atomic_3=ruleAtomic();

                    state._fsp--;


                    			current = this_Atomic_3;
                    			afterParserOrEnumRuleCall();
                    		

                    }
                    break;

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "rulePrimary"


    // $ANTLR start "entryRuleAtomic"
    // InternalSetting.g:2075:1: entryRuleAtomic returns [EObject current=null] : iv_ruleAtomic= ruleAtomic EOF ;
    public final EObject entryRuleAtomic() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleAtomic = null;


        try {
            // InternalSetting.g:2075:47: (iv_ruleAtomic= ruleAtomic EOF )
            // InternalSetting.g:2076:2: iv_ruleAtomic= ruleAtomic EOF
            {
             newCompositeNode(grammarAccess.getAtomicRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleAtomic=ruleAtomic();

            state._fsp--;

             current =iv_ruleAtomic; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleAtomic"


    // $ANTLR start "ruleAtomic"
    // InternalSetting.g:2082:1: ruleAtomic returns [EObject current=null] : ( ( () ( (lv_value_1_0= ruleEBigDecimal ) ) ) | ( () ( (otherlv_3= RULE_ID ) ) ) ) ;
    public final EObject ruleAtomic() throws RecognitionException {
        EObject current = null;

        Token otherlv_3=null;
        AntlrDatatypeRuleToken lv_value_1_0 = null;



        	enterRule();

        try {
            // InternalSetting.g:2088:2: ( ( ( () ( (lv_value_1_0= ruleEBigDecimal ) ) ) | ( () ( (otherlv_3= RULE_ID ) ) ) ) )
            // InternalSetting.g:2089:2: ( ( () ( (lv_value_1_0= ruleEBigDecimal ) ) ) | ( () ( (otherlv_3= RULE_ID ) ) ) )
            {
            // InternalSetting.g:2089:2: ( ( () ( (lv_value_1_0= ruleEBigDecimal ) ) ) | ( () ( (otherlv_3= RULE_ID ) ) ) )
            int alt30=2;
            int LA30_0 = input.LA(1);

            if ( (LA30_0==RULE_INT||LA30_0==38) ) {
                alt30=1;
            }
            else if ( (LA30_0==RULE_ID) ) {
                alt30=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 30, 0, input);

                throw nvae;
            }
            switch (alt30) {
                case 1 :
                    // InternalSetting.g:2090:3: ( () ( (lv_value_1_0= ruleEBigDecimal ) ) )
                    {
                    // InternalSetting.g:2090:3: ( () ( (lv_value_1_0= ruleEBigDecimal ) ) )
                    // InternalSetting.g:2091:4: () ( (lv_value_1_0= ruleEBigDecimal ) )
                    {
                    // InternalSetting.g:2091:4: ()
                    // InternalSetting.g:2092:5: 
                    {

                    					current = forceCreateModelElement(
                    						grammarAccess.getAtomicAccess().getBigDecimalConstantAction_0_0(),
                    						current);
                    				

                    }

                    // InternalSetting.g:2098:4: ( (lv_value_1_0= ruleEBigDecimal ) )
                    // InternalSetting.g:2099:5: (lv_value_1_0= ruleEBigDecimal )
                    {
                    // InternalSetting.g:2099:5: (lv_value_1_0= ruleEBigDecimal )
                    // InternalSetting.g:2100:6: lv_value_1_0= ruleEBigDecimal
                    {

                    						newCompositeNode(grammarAccess.getAtomicAccess().getValueEBigDecimalParserRuleCall_0_1_0());
                    					
                    pushFollow(FOLLOW_2);
                    lv_value_1_0=ruleEBigDecimal();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getAtomicRule());
                    						}
                    						set(
                    							current,
                    							"value",
                    							lv_value_1_0,
                    							"org.eclipse.lsat.setting.teditor.Setting.EBigDecimal");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }


                    }


                    }
                    break;
                case 2 :
                    // InternalSetting.g:2119:3: ( () ( (otherlv_3= RULE_ID ) ) )
                    {
                    // InternalSetting.g:2119:3: ( () ( (otherlv_3= RULE_ID ) ) )
                    // InternalSetting.g:2120:4: () ( (otherlv_3= RULE_ID ) )
                    {
                    // InternalSetting.g:2120:4: ()
                    // InternalSetting.g:2121:5: 
                    {

                    					current = forceCreateModelElement(
                    						grammarAccess.getAtomicAccess().getDeclarationRefAction_1_0(),
                    						current);
                    				

                    }

                    // InternalSetting.g:2127:4: ( (otherlv_3= RULE_ID ) )
                    // InternalSetting.g:2128:5: (otherlv_3= RULE_ID )
                    {
                    // InternalSetting.g:2128:5: (otherlv_3= RULE_ID )
                    // InternalSetting.g:2129:6: otherlv_3= RULE_ID
                    {

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getAtomicRule());
                    						}
                    					
                    otherlv_3=(Token)match(input,RULE_ID,FOLLOW_2); 

                    						newLeafNode(otherlv_3, grammarAccess.getAtomicAccess().getDeclarationDeclarationCrossReference_1_1_0());
                    					

                    }


                    }


                    }


                    }
                    break;

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleAtomic"


    // $ANTLR start "entryRuleEBigDecimal"
    // InternalSetting.g:2145:1: entryRuleEBigDecimal returns [String current=null] : iv_ruleEBigDecimal= ruleEBigDecimal EOF ;
    public final String entryRuleEBigDecimal() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleEBigDecimal = null;


        try {
            // InternalSetting.g:2145:51: (iv_ruleEBigDecimal= ruleEBigDecimal EOF )
            // InternalSetting.g:2146:2: iv_ruleEBigDecimal= ruleEBigDecimal EOF
            {
             newCompositeNode(grammarAccess.getEBigDecimalRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleEBigDecimal=ruleEBigDecimal();

            state._fsp--;

             current =iv_ruleEBigDecimal.getText(); 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleEBigDecimal"


    // $ANTLR start "ruleEBigDecimal"
    // InternalSetting.g:2152:1: ruleEBigDecimal returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : ( (kw= '-' )? this_INT_1= RULE_INT (kw= '.' this_INT_3= RULE_INT )? ( (kw= 'E' | kw= 'e' ) (kw= '-' )? this_INT_7= RULE_INT )? ) ;
    public final AntlrDatatypeRuleToken ruleEBigDecimal() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;
        Token this_INT_1=null;
        Token this_INT_3=null;
        Token this_INT_7=null;


        	enterRule();

        try {
            // InternalSetting.g:2158:2: ( ( (kw= '-' )? this_INT_1= RULE_INT (kw= '.' this_INT_3= RULE_INT )? ( (kw= 'E' | kw= 'e' ) (kw= '-' )? this_INT_7= RULE_INT )? ) )
            // InternalSetting.g:2159:2: ( (kw= '-' )? this_INT_1= RULE_INT (kw= '.' this_INT_3= RULE_INT )? ( (kw= 'E' | kw= 'e' ) (kw= '-' )? this_INT_7= RULE_INT )? )
            {
            // InternalSetting.g:2159:2: ( (kw= '-' )? this_INT_1= RULE_INT (kw= '.' this_INT_3= RULE_INT )? ( (kw= 'E' | kw= 'e' ) (kw= '-' )? this_INT_7= RULE_INT )? )
            // InternalSetting.g:2160:3: (kw= '-' )? this_INT_1= RULE_INT (kw= '.' this_INT_3= RULE_INT )? ( (kw= 'E' | kw= 'e' ) (kw= '-' )? this_INT_7= RULE_INT )?
            {
            // InternalSetting.g:2160:3: (kw= '-' )?
            int alt31=2;
            int LA31_0 = input.LA(1);

            if ( (LA31_0==38) ) {
                alt31=1;
            }
            switch (alt31) {
                case 1 :
                    // InternalSetting.g:2161:4: kw= '-'
                    {
                    kw=(Token)match(input,38,FOLLOW_39); 

                    				current.merge(kw);
                    				newLeafNode(kw, grammarAccess.getEBigDecimalAccess().getHyphenMinusKeyword_0());
                    			

                    }
                    break;

            }

            this_INT_1=(Token)match(input,RULE_INT,FOLLOW_40); 

            			current.merge(this_INT_1);
            		

            			newLeafNode(this_INT_1, grammarAccess.getEBigDecimalAccess().getINTTerminalRuleCall_1());
            		
            // InternalSetting.g:2174:3: (kw= '.' this_INT_3= RULE_INT )?
            int alt32=2;
            int LA32_0 = input.LA(1);

            if ( (LA32_0==12) ) {
                alt32=1;
            }
            switch (alt32) {
                case 1 :
                    // InternalSetting.g:2175:4: kw= '.' this_INT_3= RULE_INT
                    {
                    kw=(Token)match(input,12,FOLLOW_39); 

                    				current.merge(kw);
                    				newLeafNode(kw, grammarAccess.getEBigDecimalAccess().getFullStopKeyword_2_0());
                    			
                    this_INT_3=(Token)match(input,RULE_INT,FOLLOW_41); 

                    				current.merge(this_INT_3);
                    			

                    				newLeafNode(this_INT_3, grammarAccess.getEBigDecimalAccess().getINTTerminalRuleCall_2_1());
                    			

                    }
                    break;

            }

            // InternalSetting.g:2188:3: ( (kw= 'E' | kw= 'e' ) (kw= '-' )? this_INT_7= RULE_INT )?
            int alt35=2;
            int LA35_0 = input.LA(1);

            if ( ((LA35_0>=41 && LA35_0<=42)) ) {
                alt35=1;
            }
            switch (alt35) {
                case 1 :
                    // InternalSetting.g:2189:4: (kw= 'E' | kw= 'e' ) (kw= '-' )? this_INT_7= RULE_INT
                    {
                    // InternalSetting.g:2189:4: (kw= 'E' | kw= 'e' )
                    int alt33=2;
                    int LA33_0 = input.LA(1);

                    if ( (LA33_0==41) ) {
                        alt33=1;
                    }
                    else if ( (LA33_0==42) ) {
                        alt33=2;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 33, 0, input);

                        throw nvae;
                    }
                    switch (alt33) {
                        case 1 :
                            // InternalSetting.g:2190:5: kw= 'E'
                            {
                            kw=(Token)match(input,41,FOLLOW_42); 

                            					current.merge(kw);
                            					newLeafNode(kw, grammarAccess.getEBigDecimalAccess().getEKeyword_3_0_0());
                            				

                            }
                            break;
                        case 2 :
                            // InternalSetting.g:2196:5: kw= 'e'
                            {
                            kw=(Token)match(input,42,FOLLOW_42); 

                            					current.merge(kw);
                            					newLeafNode(kw, grammarAccess.getEBigDecimalAccess().getEKeyword_3_0_1());
                            				

                            }
                            break;

                    }

                    // InternalSetting.g:2202:4: (kw= '-' )?
                    int alt34=2;
                    int LA34_0 = input.LA(1);

                    if ( (LA34_0==38) ) {
                        alt34=1;
                    }
                    switch (alt34) {
                        case 1 :
                            // InternalSetting.g:2203:5: kw= '-'
                            {
                            kw=(Token)match(input,38,FOLLOW_39); 

                            					current.merge(kw);
                            					newLeafNode(kw, grammarAccess.getEBigDecimalAccess().getHyphenMinusKeyword_3_1());
                            				

                            }
                            break;

                    }

                    this_INT_7=(Token)match(input,RULE_INT,FOLLOW_2); 

                    				current.merge(this_INT_7);
                    			

                    				newLeafNode(this_INT_7, grammarAccess.getEBigDecimalAccess().getINTTerminalRuleCall_3_2());
                    			

                    }
                    break;

            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleEBigDecimal"


    // $ANTLR start "entryRuleIID"
    // InternalSetting.g:2221:1: entryRuleIID returns [String current=null] : iv_ruleIID= ruleIID EOF ;
    public final String entryRuleIID() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleIID = null;


        try {
            // InternalSetting.g:2221:43: (iv_ruleIID= ruleIID EOF )
            // InternalSetting.g:2222:2: iv_ruleIID= ruleIID EOF
            {
             newCompositeNode(grammarAccess.getIIDRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleIID=ruleIID();

            state._fsp--;

             current =iv_ruleIID.getText(); 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleIID"


    // $ANTLR start "ruleIID"
    // InternalSetting.g:2228:1: ruleIID returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_INT_0= RULE_INT | this_ID_1= RULE_ID ) ;
    public final AntlrDatatypeRuleToken ruleIID() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token this_INT_0=null;
        Token this_ID_1=null;


        	enterRule();

        try {
            // InternalSetting.g:2234:2: ( (this_INT_0= RULE_INT | this_ID_1= RULE_ID ) )
            // InternalSetting.g:2235:2: (this_INT_0= RULE_INT | this_ID_1= RULE_ID )
            {
            // InternalSetting.g:2235:2: (this_INT_0= RULE_INT | this_ID_1= RULE_ID )
            int alt36=2;
            int LA36_0 = input.LA(1);

            if ( (LA36_0==RULE_INT) ) {
                alt36=1;
            }
            else if ( (LA36_0==RULE_ID) ) {
                alt36=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 36, 0, input);

                throw nvae;
            }
            switch (alt36) {
                case 1 :
                    // InternalSetting.g:2236:3: this_INT_0= RULE_INT
                    {
                    this_INT_0=(Token)match(input,RULE_INT,FOLLOW_2); 

                    			current.merge(this_INT_0);
                    		

                    			newLeafNode(this_INT_0, grammarAccess.getIIDAccess().getINTTerminalRuleCall_0());
                    		

                    }
                    break;
                case 2 :
                    // InternalSetting.g:2244:3: this_ID_1= RULE_ID
                    {
                    this_ID_1=(Token)match(input,RULE_ID,FOLLOW_2); 

                    			current.merge(this_ID_1);
                    		

                    			newLeafNode(this_ID_1, grammarAccess.getIIDAccess().getIDTerminalRuleCall_1());
                    		

                    }
                    break;

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleIID"


    // $ANTLR start "entryRuleResourceQualifiedName"
    // InternalSetting.g:2255:1: entryRuleResourceQualifiedName returns [String current=null] : iv_ruleResourceQualifiedName= ruleResourceQualifiedName EOF ;
    public final String entryRuleResourceQualifiedName() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleResourceQualifiedName = null;


        try {
            // InternalSetting.g:2255:61: (iv_ruleResourceQualifiedName= ruleResourceQualifiedName EOF )
            // InternalSetting.g:2256:2: iv_ruleResourceQualifiedName= ruleResourceQualifiedName EOF
            {
             newCompositeNode(grammarAccess.getResourceQualifiedNameRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleResourceQualifiedName=ruleResourceQualifiedName();

            state._fsp--;

             current =iv_ruleResourceQualifiedName.getText(); 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleResourceQualifiedName"


    // $ANTLR start "ruleResourceQualifiedName"
    // InternalSetting.g:2262:1: ruleResourceQualifiedName returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_IID_0= ruleIID (kw= '.' this_IID_2= ruleIID )? ) ;
    public final AntlrDatatypeRuleToken ruleResourceQualifiedName() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;
        AntlrDatatypeRuleToken this_IID_0 = null;

        AntlrDatatypeRuleToken this_IID_2 = null;



        	enterRule();

        try {
            // InternalSetting.g:2268:2: ( (this_IID_0= ruleIID (kw= '.' this_IID_2= ruleIID )? ) )
            // InternalSetting.g:2269:2: (this_IID_0= ruleIID (kw= '.' this_IID_2= ruleIID )? )
            {
            // InternalSetting.g:2269:2: (this_IID_0= ruleIID (kw= '.' this_IID_2= ruleIID )? )
            // InternalSetting.g:2270:3: this_IID_0= ruleIID (kw= '.' this_IID_2= ruleIID )?
            {

            			newCompositeNode(grammarAccess.getResourceQualifiedNameAccess().getIIDParserRuleCall_0());
            		
            pushFollow(FOLLOW_43);
            this_IID_0=ruleIID();

            state._fsp--;


            			current.merge(this_IID_0);
            		

            			afterParserOrEnumRuleCall();
            		
            // InternalSetting.g:2280:3: (kw= '.' this_IID_2= ruleIID )?
            int alt37=2;
            int LA37_0 = input.LA(1);

            if ( (LA37_0==12) ) {
                int LA37_1 = input.LA(2);

                if ( (LA37_1==RULE_INT) ) {
                    int LA37_3 = input.LA(3);

                    if ( (LA37_3==EOF||LA37_3==12) ) {
                        alt37=1;
                    }
                }
                else if ( (LA37_1==RULE_ID) ) {
                    int LA37_4 = input.LA(3);

                    if ( (LA37_4==EOF||LA37_4==12) ) {
                        alt37=1;
                    }
                }
            }
            switch (alt37) {
                case 1 :
                    // InternalSetting.g:2281:4: kw= '.' this_IID_2= ruleIID
                    {
                    kw=(Token)match(input,12,FOLLOW_8); 

                    				current.merge(kw);
                    				newLeafNode(kw, grammarAccess.getResourceQualifiedNameAccess().getFullStopKeyword_1_0());
                    			

                    				newCompositeNode(grammarAccess.getResourceQualifiedNameAccess().getIIDParserRuleCall_1_1());
                    			
                    pushFollow(FOLLOW_2);
                    this_IID_2=ruleIID();

                    state._fsp--;


                    				current.merge(this_IID_2);
                    			

                    				afterParserOrEnumRuleCall();
                    			

                    }
                    break;

            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleResourceQualifiedName"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000001000000862L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000001000000062L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000000000062L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000000000000060L});
    public static final BitSet FOLLOW_9 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_10 = new BitSet(new long[]{0x000000000001C000L});
    public static final BitSet FOLLOW_11 = new BitSet(new long[]{0x0000000000008020L});
    public static final BitSet FOLLOW_12 = new BitSet(new long[]{0x0000000000018000L});
    public static final BitSet FOLLOW_13 = new BitSet(new long[]{0x0000000000000020L});
    public static final BitSet FOLLOW_14 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_15 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_16 = new BitSet(new long[]{0x00000000000C0002L});
    public static final BitSet FOLLOW_17 = new BitSet(new long[]{0x0000000000080002L});
    public static final BitSet FOLLOW_18 = new BitSet(new long[]{0x0000000000200020L});
    public static final BitSet FOLLOW_19 = new BitSet(new long[]{0x0000000000300000L});
    public static final BitSet FOLLOW_20 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_21 = new BitSet(new long[]{0x0000004000200060L});
    public static final BitSet FOLLOW_22 = new BitSet(new long[]{0x0000004958200060L});
    public static final BitSet FOLLOW_23 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_24 = new BitSet(new long[]{0x0000000000800020L});
    public static final BitSet FOLLOW_25 = new BitSet(new long[]{0x0000000000C00000L});
    public static final BitSet FOLLOW_26 = new BitSet(new long[]{0x0000000007000000L});
    public static final BitSet FOLLOW_27 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_28 = new BitSet(new long[]{0x0000000006000000L});
    public static final BitSet FOLLOW_29 = new BitSet(new long[]{0x0000000004000000L});
    public static final BitSet FOLLOW_30 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_31 = new BitSet(new long[]{0x0000000001000000L});
    public static final BitSet FOLLOW_32 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_33 = new BitSet(new long[]{0x0000000020000000L});
    public static final BitSet FOLLOW_34 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_35 = new BitSet(new long[]{0x0000000200000000L});
    public static final BitSet FOLLOW_36 = new BitSet(new long[]{0x0000000400000000L});
    public static final BitSet FOLLOW_37 = new BitSet(new long[]{0x0000006000000002L});
    public static final BitSet FOLLOW_38 = new BitSet(new long[]{0x0000018000000002L});
    public static final BitSet FOLLOW_39 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_40 = new BitSet(new long[]{0x0000060000001002L});
    public static final BitSet FOLLOW_41 = new BitSet(new long[]{0x0000060000000002L});
    public static final BitSet FOLLOW_42 = new BitSet(new long[]{0x0000004000000040L});
    public static final BitSet FOLLOW_43 = new BitSet(new long[]{0x0000000000001002L});

}